   This file, last updated 3 November 2008, documents the `texi2html'
script which converts Texinfo (http://www.texinfo.org) into HTML
(http://w3c.org).  This edition is for `texi2html' version 1.82.

Texi2HTML
*********

This manual, last updated 3 November 2008, describes version 1.82 of
the `texi2html' Perl script which converts Texinfo (see Texinfo)
into HTML.

   Please send bug reports concerning this manual to the Texi2HTML
developement list <texi2html-bug@nongnu.org>. Please state the exact
version of the manual which contains the bug, as given above.

Portions
of
`texi2html'
          Copyright (C) 1999, 2000 Lionel Cons
          Copyright (C) 1999, 2000 Karl Berry
          Copyright (C) 1999, 2000 Olaf Bachmann
          Copyright (C) 2002, 2003, 2004, 2005, 2006, 2007 Patrice Dumas
          Copyright (C) 2001, 2002, 2003, 2004, 2005, 2006 Derek Price
          Copyright (C) many others.

Portions
of this
manual
          Copyright (C) 1999, 2000 Karl Heinz Marbaise (manual)
          Copyright (C) 2003, 2007 Derek Price (manual)
          Copyright (C) 2003, 2004, 2005, 2006, 2007 Patrice Dumas
          (manual)

   Permission is granted to make and distribute verbatim copies of this
manual provided the copyright notice and this permission notice are
preserved on all copies.

   Permission is granted to copy and distribute modified versions of
this manual under the conditions for verbatim copying, provided that
the entire resulting derived work is distributed under the terms of a
permission notice identical to this one.

   Permission is granted to copy and distribute translations of this
manual into another language, under the above conditions for modified
versions, except that this permission notice may be stated in a
translation approved by the Free Software Foundation.

     *This manual is currently under construction and of course incomplete.  ;-)*

1 Overview
**********

Texinfo (http://www.texinfo.org) is the official documentation format
of the GNU (http://www.gnu.org) project.  It uses a single source file
to produce both online information and printed output.

   It is often desirable to have a way to produce HTML from Texinfo
sources, as GNU-Info files are produced.  It is much simpler to run a
converter than it is to rewrite all the documentation in HTML,
especially considering that there is so much Texinfo documentation in
the world.

   Some time ago `makeinfo' wasn't able to produce HTML output format,
but people still wanted documentation in HTML.  This was the birthing
hour for `texi2html'.  The basic purpose of `texi2html' is to convert
Texinfo documents into HTML.

   Since then, HTML support in `makeinfo' has improved, but `texi2html'
is still stronger in many areas, including the degree to which it
allows customization.  With `texi2html', some important aspects of the
resulting HTML files may be specified via command line options, and
configuration files provide an even finer degree of control over the
final output, allowing most every aspect of the final output not
specified in the Texinfo input file to be specified.  Configuration
files are written in `perl', like the main program, and anything which
may be specified on the command line may also be specified within a
configuration file.

   For an example of the kind of pages `texi2html' is capable of
producing, have a look at the following sites: the Singular Manual
(http://www.singular.uni-kl.de/Manual/html/), the Cederqvist (CVS
Manual) (http://ccvs.cvshome.org/docs/manual).

1.1 Why `texi2html' and not `makeinfo'?
=======================================

You would like to produce HTML files from your existing Texinfo files?
There are two programs you can use to do this.  The first is `makeinfo'
(see Generating HTML (texinfo)).  The second is
`texi2html'.

   The design goal of `makeinfo''s HTML output was to produce readable
HTML output. It is now possible to use CSS for HTML customization.
Another possibility is to use intermediate formats, like docbook or
`makeinfo' XML and XSL stylesheets to customize the resulting document.
Still the output produced by `makeinfo' isn't customizable.

   The current development of `texi2html' tries to provide for
producing the more interesting and sophisticated HTML pages that
today's Internet users have come to expect.  The goal behind
`texi2html' is to generate attractive HTML by default but also to allow
users considerable freedom to affect the final style and design of the
output HTML pages.  This is achieved via command line options and
flexible configuration files.

   In contrast to the HTML produced by `makeinfo --html' (the
`makeinfo' program is part of the Texinfo distribution), the
`texi2html' program, among other differences, allows for the
customization of the entire page layout, including headers, footers,
style sheets, etc., allows for customization of the low level HTML
formatting, provides for splitting documents at various levels, and
provides for using the `latex2html' program to convert `@tex' sections
of the Texinfo source.

   The focus on HTML is still present but with the help of the
customization files it is now possible to use `texi2html' to produce
other formats as well. `texi2html' may for example be turned into a
texinfo to roff translator with the help of a customization file
provided with the distribution.

   `texi2html' should reasonably convert all Texinfo 4.8 constructs.
If you find it does not, please send a bug report to the
<texi2html-bug@nongnu.org> email list.

2 Obtaining `texi2html'
***********************

The latest version of the source code for `texi2html' should be
available from www.nongnu.org/texi2html/
(http://www.nongnu.org/texi2html/).  `texi2html' is also available with
teTeX (http://www.tug.org/teTeX/) and TeX Live
(http://www.tug.org/texlive/).

3 Installation of `texi2html'
*****************************

3.1 Requirements
================

To install `texi2html', you must first obtain a copy of the source
distribution.  See Obtaining texi2html.

   `texi2html' requires `perl' version 5.00405 or above to be run. An
older perl 5 version with `File::Spec' is also likely to work.  The
current version has been lightly tested on a wide range of perl, but
has not been tested extensively on versions of `perl' below 5.6.  To
play nice with encodings you also need the `Encode' and
`Unicode::Normalize' modules.

   To rebuild the script perl isn't required in most cases. For more
information about advanced build features, see Advanced build features.

3.2 Configuring the source and rebuilding
=========================================

`texi2html' is a standard Automake-based distribution.  If you have a
source version, you should run `./configure' to configure the sources
and `make' to build the script.

   `./configure' accepts options to select the installation directory
for the `texi2html' file, the default directories `texi2html' will use
to look for configuration files, and other details.  Run `./configure
--help' for more information.  Running `./configure' creates
`texi2html_configured.pl' from `texi2html.pl', and also builds the
`make' configuration files (`Makefile's).

   Running `make' combines five files into the final `texi2html'
program file:
   * `texi2html_configured.pl' contains the base program,

   * `MySimple.pm' handles the command line options,

   * `texi2html.init' is the default configuration file, and

   * `T2h_i18n.pm' is used for internationalization.

   * `translations.pl' contains the translations of the strings used in
     documents.

   Running `make' also rebuilds the documentation if needed.

3.3 Installing
==============

`make install' performs the installation to the locations specified to
the `./configure' script.  This usually involves placing the actual
`texi2html' file someplace in your path, such as `/usr/local/bin' or
`/usr/bin'.

   Installing `texi2html' in your path should be sufficient to run it.
To use default initialization files, or a configuration file for
LaTeX2HTML when using `latex2html' to convert `@tex' sections (see
Expanding TeX regions), install them in the package data directory
specified to configure.  This is `/usr/local/share/texi2html/' by
default, but depends on the value of the `--pkgdatadir=DIR' option
passed to the `./configure' script. Files used for strings
customization and internationalization are also searched for in the
`i18n' directory of this directory. See Using init files for more.

3.4 Advanced build features
===========================

This section documents features that are unlikely to be used but deserve
a bit of documentation.

   A `./configure' switch, `--with-unicode' allows to choose whether
the unicode code should be used or not. The default is to detect it
with a test. This code requires `Encode' and `Unicode::Normalize'
modules.

   A similar `./configure' switch, `--with-unidecode' allows to choose
whether the perl module `Text::Unidecode' should be used or not. The
default is to detect it with a test. This code requires the
`Text::Unidecode' module.

   `perl' isn't needed to build the script. the script is build by
`./configure' and a shell script launched by `make' which is a simple
wrapper around a `sed' one-liner. The `perl' command can be specified
with the environment variable `$PERL', otherwise it is detected. `perl'
is required to rebuild the documentation as the HTML documentation is
rebuild with `texi2html' itself.

   The translations are managed by a script `manage_i18n.pl', created
by `./configure'. `manage_i18n.pl' requires `Data::Dumper' to function
normally. If this module isn't there `./configure' detects it and
`manage_i18n.pl' doesn't really rebuild the translations, but only copy
files. It is possible to use the `./configure' switch `--enable-translations'
to override the `./configure' detection. For more about translations,
see Internationalization.

   It is possible to build from outside of the source directory, for
example the following should work:

     tar xzvf texi2html-1.82.tar.gz
     mkdir texi2html_build
     cd texi2html_build
     ../texi2html-1.82/configure && make

   All these features enables to build `texi2html' on a platform in
order to run it on another platform, a kind of cross-building. The
`./configure' switches and `$PERL' allows to specify everything needed
for the build of the `texi2html' script.

4 Invoking `texi2html'
**********************

To produce an HTML manual, run `texi2html' with a Texinfo file as an
argument.  For example, this manual is created with:

     $ texi2html texi2html.texi

   `texi2html' can accept more than one manual on the command line, and
will proceed with each of the manuals in turn.

   The behaviour of `texi2html' may be changed with command line
options.  These command line options are always associated with
corresponding `perl' variables which may appear in init files, and these
variables are presented in this chapter each time a switch is described.

   Boolean command line switches always have a corresponding negated
switch, obtained by prepending `no' or `no-' to the switch name. For
example `--nomenu' does the reverse of `--menu'.

   When more than one manual is processed, the command line apply to
all the manuals, except for command-line switches setting the output
file names.

4.1 General options
===================

Miscellaneous general options:
`--error-limit=NUM'
     Quit after NUM errors (default 1000), (variable `$ERROR_LIMIT').

`--help'
     Display a short help and exit.

`--verbose'
     Be verbose.

`--version'
     Display version information and exit.

`--build-date=UNIXTIME'
     Use the given unix time as build date showing UTC timezone when it is used.

4.2 Specifying where to split the generated document
====================================================

The HTML manual resulting from the processing of the Texinfo source may
be split into files at different levels.  This is specified with the
option `--split' which takes an argument, namely the level of splitting
(variable: `$SPLIT'). This level may be:

`chapter'
     The document is split at `@chapter', `@appendix', or `@unnumbered'.

`section'
     The document is split at the same places as it is using the
     `chapter' argument, and also at `@section', `@appendixsec' or
     `@unnumberedsec'.

`node'
     The document is split at every sectioning command.  It is not
     necessarily split at each node, if the `@node' structure doesn't
     correspond with the sectioning command structure (see below).

`none'
     The document isn't split.  This is the default.

   There are two kinds of commands which may be used to define
sectioning elements in Texinfo: `@node' and the structuring commands
(`@top', `@section', `@appendixsubsec',  and so on).  A node just
preceding a structuring command is considered to be part of the same
sectioning element as that command.  If the `@node Top' isn't
associated with a structuring command it also defines a sectioning
element.

   By default, nodes which aren't associated with a structuring command
are not considered to be sectioning commands.  They are always
considered to be part of a sectioning element defined by a structuring
command.  It is possible to change this behaviour via the `--use-nodes'
option (variable `$USE_NODES').  In this case, nodes not associated
with structuring commands are also considered to be sectioning commands
defining a sectioning element.

   This default behaviour mimics `texi2dvi' behaviour, which ignores
`@node' commands for the purprose of sectioning, while the second looks
like `makeinfo' behaviour (see Two Paths (texinfo)).

   As an illustration, the following table shows how a sample Texinfo
document is divided into sectioning elements when `--use-nodes' is used
and not:

Texinfo code           default case           with
                                              `--use-nodes'
     @node node1        first element:         first element:
     @chapter node 1
     node1 text             @node node1             @node node1
                            @chapter node 1             @chapter node 1
     @node node2             node1 text             node1 text
     node2 text                                  second
                            @node node2        element:
     @node node3             node2 text
     node3 text           second                   @node node2
     @chapter node 3        element:                    node2 text
     chapter text                                  third
                            @node node3        element:
                            node3 text
                            @chapter node 3             @node node3
                            chapter text             node3 text
                                                   @chapter node 3
                                                   chapter text

4.3 Setting output file and directory names
===========================================

The manual name is constructed by stripping the `.texi', `.txi',
`.texinfo', or `.txinfo' extension from the Texinfo file name.

   By default, `texi2html' generates the manual file in the current
directory if the manual isn't split. A `.html' file extension is
appended to the manual name.

   If the manual is split the files are put in a directory named after
the manual name. The file name is constructed using the manual name as
basename.  An underscore followed by a number is appended to the
basename for each files corresponding with sectioning elements, with the
exception of the top element. For the top element there is nothing
appended.  The files containing special elements pages have an
underscore and a 3 letter code corresponding to their content (`toc'
for table of contents, `abt' for about, `ovr' for overview, `fot' for
footnotes if they are separated) appended.  Lastly, an `.html' file
extension is appended.

   Thus, if the texinfo file `afile.texi' is processed and split at
chapters into 3 files, the generated files (in directory `afile') will
be:

     afile.html         --> `@node Top' or `@top' section
     afile_1.html       --> Chapter 1
     afile_2.html       --> Chapter 2
     afile_toc.html     --> Table of Contents
     afile_abt.html     --> About Page

   This default behavior may be modified by several command line
options. If the output isn't split, the prefix file name may be
overrided by the `--output' command line option (variable `$OUT'). If
the output is split, and `--output' is set, the files are placed in the
directory specified by the argument to the option.

   The basename may be overridden with `--prefix' (variable `$PREFIX').
If `--short-ext' is given, `.htm' is appended instead of `.html' in the
final step (variable `$SHORTEXTN').  The `--top-file' option overrides
the top element file name (variable `$TOP_FILE').  This can be used to
name the top element file `index.html'.  Similarly, `--toc-file'
changes the name of the table of contents file (variable `$TOC_FILE').

   Reusing the example above, but this time calling `texi2html' like so:

     $ texi2html -split chapter -prefix manual -short-ext -top-file index.htm -toc-file contents.htm afile.texi

   we get, in `manual':

     index.htm          --> `@node Top' or `@top' section
     manual_1.htm       --> Chapter 1
     manual_2.htm       --> Chapter 2
     contents.htm       --> Table of Contents
     manual_abt.htm     --> About Page

   The file names generated by `texi2html' differ from those generated
by `makeinfo'. `makeinfo' uses the `@setfilename' to determine the
manual name(1) (1).  Also `makeinfo' uses
the node name to construct the file names while splitting at nodes.

   It is possible to get the same behaviour out of `texi2html' by
specifying the `--node-files' option (variable `$NODE_FILES').  The
default is false for this option.  If the output isn't split at nodes,
`texi2html' will still output files named after the nodes, without real
content but redirecting to the right file.  This trick enables the
generated HTML manual to be a target for the cross-references of other
manuals generated by `makeinfo' or `texi2html'.

   In case the files are named after the node names, another
command-line option, `--transliterate-file-names' can be set to trigger
ASCII transliteration of node file names (variable `$TRANSLITERATE_NODE').
Transliteration is set in the default case.

   (1) This behaviour is triggered only by a variable set in an init
file,  `$USE_SETFILENAME' (see Using init files).

4.4 Specifying which regions get expanded
=========================================

The default for `texi2html' is to expand the `@ifhtml', `@html', and
`@menu' regions, all the `@ifnot' regions except `@ifnothtml', and no
other `@if' regions.

   It is possible to expand other regions by setting `--if<region>',
where `<region>' is replaced by the literal name of the region (for
example, `--iftex').  Symetrically, if `--no-if<region>' is specified,
the `<region>' region is ignored.  The configuration file array, `@EXPAND',
holds the names of regions which should be expanded. The only region
name present in `@EXPAND' in the default case is `html'.

   If `--nomenu' is set, the `@menu' sections are not expanded
(variable `$SHOW_MENU'). The default is to expand `@menu' sections.

4.5 Command line options related to Texinfo language features
=============================================================

Miscalleneous Texinfo related things may be specified via command line
options.

`--lang=LANG'
     Sets the document language similar to the Texinfo directive,
     `@documentlanguage LANG' (variable `$LANG').  The default is `en',
     that is, use the english language strings.

`-DVAR'
     Sets VAR.  Equivalent to, `@set VAR 1', in Texinfo.

`-UVAR'
     Clears VAR.  Equivalent to, `@clear VAR', in Texinfo.

`-PDIR'
     Prepend DIR to the list of directories to search for `@include'
     files (the associated array is `@PREPEND_DIRS', empty in the
     default case).

`-IDIR'
     Append DIR to the list of directories to search for `@include'
     files (the associated array is `@INCLUDE_DIRS', empty in the
     default case).

   The include files are always searched for in the current directory.

4.6 Page layout related command line options
============================================

If the `--frames' option is specified, HTML frames are used.  A file
describing the frame layout is generated, and the document page is
associated with a frame where the short table of content appears
(variable `$FRAMES'). The default is not to use frames.

   It is also possible to suppress the section navigation panel with `--no-headers'
(variable `$SECTION_NAVIGATION', the default is to output all the
navigation panels), and to specify whether footnotes should appear at
the foot of the same page which contains the reference to the note with `--footnote-style'
set to `end' or on a separate page with `--footnote-style' set to
`separate' (variable `$SEPARATED_FOOTNOTES' set to 0 or 1).  The
default is to have separated footnotes.

4.7 Customizing the HTML and text style
=======================================

Miscalleneous style changes may be achieved with command line options.

`--doctype=DTD'
`--frameset-doctype=DTD'
     You can specify the document DTD by setting these options.  `--frameset-doctype'
     applies to the file describing the frames when frames are used
     (corresponding variables are `$DOCTYPE' and `$FRAMESET_DOCTYPE').

     The default for the document doctype is:
          <!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html401/loose.dtd">
     And for the frameset doctype:
          <!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Frameset//EN" "http://www.w3.org/TR/html401/frameset.dtd">

`--iso'
     If this option is set, ISO8859 entities are used for some special
     symbols, like Copyright (C) (variable `$USE_ISO'). It is the
     default.

`--css-include=FILE'
     This command line switch provides for the inclusion of an external
     Cascading Style Sheet (CSS) file.  More than one file may be
     specified, and `-' stands for the standard input (array `@CSS_FILES').

     The option use is the same than for `makeinfo' and is described
     extensively in HTML CSS (texinfo).  Briefly, the
     CSS `@import' lines from the external file CSS file are pasted
     before the `texi2html' CSS rules, and the external file CSS rules
     are pasted after the `texi2html' CSS rules.

`--css-ref=URL'
     This command line switch provides for the inclusion of an reference
     to a Cascading Style Sheet (CSS) URL.  More than one URL may be
     specified (array `@CSS_REFS').

`--html-xref-prefix=PATH'
     This option sets the base directory for external HTML texinfo
     manuals (variable `$EXTERNAL_DIR').  Defaults to `../'.

`--def-table'
     If this option is set, HTML tables are used to format definition
     commands, rather than HTML definition tables (variable `$DEF_TABLE').
     Default is false.

`--short-ref'
     If this option is set, cross-references are given without section
     numbers (variable `$SHORT_REF'). Default is false.

`--number-sections'
     If this option is set, sections are numbered (variable `$NUMBER_SECTIONS').
     This is the default.

`--toc-links'
     If this option is set, links from headings to TOC entries are
     created (variable `$TOC_LINKS'). Default is false.

4.8 Expanding `@tex' and `@math' regions using LaTeX2HTML
=========================================================

It is possible to use LaTeX2HTML (http://www.latex2html.org/) to
process `@tex' regions and `@math{}' commands.  This is an attractive
way to display mathematical constructs in the HTML manual.  The `--l2h'
option activates this feature (variable $L2H).  It is usually desirable
to expand `@tex' sections when this option is specified (see
Expansion). The default is not to use this feature.

   The `--l2h-l2h=PROGRAM' option enables changing the name/location of
the LaTeX2HTML program processing TeX regions (variable `$L2H_L2H').
The default is `latex2html'.

   `--l2h-tmp' sets the directory used for temporary files, this name
shouldn't contain a dot `.' (variable is `$L2H_TMP'). Defaults to the
current dir.

   The file specified by `--l2h-file' is used as LaTeX2HTML init file.
It is searched at the same places than init files (see Using init files),
and the default is `l2h.init'.

4.9 Use initialization files for fine tuning
============================================

Initialization variables are read first from
`/usr/local/share/texi2html/Config' (the exact location being
changeable with the `--pkgdatadir=dir' option of the `configure'
script, see Installation), `/usr/local/etc/texi2html/Config'
(the exact location being changeable with the `--sysconfdir=dir' option
of the `configure' script, see Installation), from `./Config'
then from `$HOME/.texi2html/Config'. Any command-line option can
override the corresponding option set in init file, and the option `--init-file'
specifies an init file to be loaded, with later settings overriding
earlier ones.

   The init files specified with `--init-file' are searched first in
the current directory, then in the `$HOME/.texi2html/' directory, in
the `/usr/local/etc/texi2html/' directory and lastly in the
`/usr/local/share/texi2html/' directory.

   A file is also included based on the language selected, by `$LANG', `--document-language'
or `@documentlanguage'.  If no language was selected `en' is considered
to be the language. All the files with name the language name in
`/usr/local/share/texi2html/i18n/', `/usr/local/etc/texi2html/i18n/',
`$HOME/.texi2html/i18n/' and then `./i18n/' are included.

   The default initialization options are defined in the
`texi2html.init' file contained in the `texi2html' distribution (which
gets included near the beginning of the `texi2html' script that gets
installed).

   To customize `texi2html' it is best if you copy the appropriate
sections from the `texi2html.init' contents into an appropriate local
initialization file, make the necessary changes there, and then have
`texi2html' read this initialization file by one of the means described
above.

   Some init files are provided with `texi2html', for example
`book.init' which produces an output more in line with what could be in
a book, or `chm.init' outputs files that can be used to produce a CHM
file.

5 Overview of initialization files content and loading
******************************************************

The initialization files are `perl' files, read as explained in
Using init files. You don't need to know much of `perl' to do some
simple changes in variable values, however, to be able to really take
advantage of all the features of the initialization file, a good
knowledge of `perl' is required.

   In initialization file two kind of variables appear. These are normal
variables (including arrays and hashes) and references on functions.
The later permits the dynamic redefinition of functions used to produce
the HTML manual. You should be able to change the value of some normal
variables without a deep knowledge of `perl', by looking at the
existing examples. The possible mistakes in that case could be omitted
`;', and bad quoting.

   Initialization file are loaded from the main program by the mean of
a `require', while in the `Texi2HTML::Config' namespace. This means
that the namespace of the main program and the namespace of
initialization files are distinct, which ensures that no name clash
should happen. The variables are declared with `use vars', such that it
should be possible to use the `use strict' pragma in the initialization
file code.

   To avoid messing with the variables in the `main' namespace all the
global variables which could be of use in the init files are in the
`Texi2HTML' namespace. Notice that the functions of the main program
are still in the `main' namespace.

   Since `texi2html' can proceed more than one file on the command
line, you should make sure that you initialize the variables that are
used during a manual formatting. The handlers explained later can be
used for that (see Bypassing normal formatting).

5.1 Setting the encodings
=========================

There are four encodings relevant for `texi2html', they are associated
with corresponding configuration variables. If these variables are
defined they determine a corresponding value in `%Texi2HTML::THISDOC'
which is otherwise autodetected:
  1. The variable `$DOCUMENT_ENCODING' corresponds with the document
     encoding.  If defined, this variable sets `$Texi2HTML::THISDOC{'DOCUMENT_ENCODING'}'.
     If not defined, the encoding appearing in `@documentencoding' will
     be used to set `$Texi2HTML::THISDOC{'DOCUMENT_ENCODING'}'.  The
     `@documentencoding' value appears in `$Texi2HTML::THISDOC{'documentencoding'}'.

  2. The texinfo files encoding.  If `$IN_ENCODING' is set, this sets `$Texi2HTML::THISDOC{'IN_ENCODING'}'.
     Otherwise, when `$Texi2HTML::THISDOC{'DOCUMENT_ENCODING'}' is set,
     `$Texi2HTML::THISDOC{'IN_ENCODING'}' is also set if the encoding
     is supported by perl.

  3. The out files encoding. It is associated with the variable `$OUT_ENCODING'.
     If defined, `$Texi2HTML::THISDOC{'OUT_ENCODING'}' is set
     accordingly.  If not defined, the value of
     `$Texi2HTML::THISDOC{'ENCODING_NAME'}' or
     `$Texi2HTML::THISDOC{'IN_ENCODING'}' is used if one of these
     variables is set.

  4. The encoding advertized in out files, associated with the variable `$ENCODING_NAME'.
     It sets `$Texi2HTML::THISDOC{'ENCODING_NAME'}' if defined.

     If unset the value of this variable is based on the other ENCODING
     values, and if they are all undefined, the variable `$DEFAULT_ENCODING'
     is used.

   The values for the encoding related variables are set in the default
`init_out' function reference (see Output initialization).

   In general the `$DOCUMENT_ENCODING' and `$IN_ENCODING' are set to
the right values. `$OUT_ENCODING' is also rightly set according to
`$ENCODING_NAME'.  To force a given encoding for the output, the
`$ENCODING_NAME' value may be set. The current default output encoding
is UTF-8.

5.2 Redefining functions in initialization files
================================================

To redefine a function you must replace the corresponding funtion
reference with a reference on your function.  Thus you should write
your function, give it a name you are certain it is unique in the
`Texi2HTML::Config' namespace, and override the value of the function
reference with your own function reference. When another function from
the main program (or from another functions of an initialization file)
calls the reference, your function will be used.

   For example the function reference corresponding with the function
called when doing an anchor is called `$anchor'. Thus if you want to
override the corresponding function you could write:

     # override the function reference
     $anchor = \&my_own_function;

     # the function reference now refers to
     sub my_own_function {
     # process arguments and return an html anchor
     }

5.3 Conventions used for function prototypes
============================================

As the functions are defined by a reference name, we will always use
the reference name in function prototypes. For the function arguments
we will use `\@array' for a reference on an array and similarly
`\%hash' for a reference on a hash.

   Thus, the prototype for the function associated with the function
reference `$formatting_function' will be:

 -- Function Reference: $text formatting_function $arg1 \@arg2
     `formatting_function' takes as first argument $ARG2, as second
     argument a reference on an array \@ARG2 and returns the formatted
     text $TEXT.

   To redefined the corresponding function, you should write:

     $formatting_function = \&my_formatting_function

     sub my_formatting_function($ $)
     {
         my $arg1 = shift;
         my $arg2 = shift;
         # prepare $formatted_text
         .....
         return $formatted_text
     }

6 Fine tuning of the page layout
********************************

Some features of the page layout might be specified with command line
options, the corresponding variables are described in Page layout options.
Fine tuning of the page layout may be achieved with
redefinition of other variables and function references in the
initialization files.

6.1 The different categories of pages and sectioning elements
=============================================================

The following sectioning elements can be associated with pages:

_Normal elements_
     These are normal sections or nodes. Their association with pages is
     determined by the splitting of the document. See Splitting output.

_Top element_
     The top element is the higher element in the document structure.
     If there is a `@top' section it is the element associated with
     that section. Otherwise it is the element associated with the
     `@node Top'. If there is no `@node Top' the first element is the
     top element.

     The top element is formatted differently than a normal element if
     there is a `@top' section or the `@node Top' isn't associated with
     a sectioning command.

_Misc elements_
     These elements are associated with pages if the document is split.
     There are four misc elements:
       1. Table of contents

       2. Short table of contents, also called Overview

       3. Footnotes page

       4. About page

     The _About page_ shouldn't be present for documents consisting in
     only one sectioning element, or for documents unsplit and without
     navigation information. The _Footnote page_ should only be present
     if the footnotes appear on a separated page (see Page layout options),
     however a footnote element is present if the document
     isn't split. The _Table of contents_ should only be formatted if
     `@contents' is present in the document.  Similarly the _Overview_
     should only appear if `@shortcontents' or `@summarycontents' is
     present. The Table of contents and the Overview may also be
     directly included within the document, not as separate pages
     (see Contents and Overview text).

6.2 Page layout and navigation panel overview
=============================================

A page is broken up in three parts. A page header, the sections and a
page footer. A common element in the page layout is a navigation panel
with icons or text linking to other sections or pages. Another common
element is a rule, separating sections or footer. The navigation panel
and the rules may be part of the sections or part of headers or
footers. You may use the variables `$SMALL_RULE', `$DEFAULT_RULE', `$MIDDLE_RULE'
and `$BIG_RULE' for rules of different sizes.  The defaults are
     $SMALL_RULE = '<hr size="1">';
     $DEFAULT_RULE = '<hr>';
     $MIDDLE_RULE = '<hr size="2">';
     $BIG_RULE = '<hr size="6">';

   In the header some important meta data may be defined, like the
title or style information, and textual informations may be present in
comments. All this doesn't appear directly in the displayed HTML,
though.

   The page layout is mainly controlled by functions, the precise
functions called depending on the document splitting. The navigation
panel, however, can be customized with variables.

Element labels
--------------

There are 19 items associated with elements. Each of these is
associated with a name and a reference to the element they represent,
when such an element exists.  The element is either a global element or
an element relative to the current element. The relative elements are
found with respect with the document structure defined by the section
structuring commands (`@chapter', `@unnumbered'...) or by the nodes (in
that case the node directions are specified on node line or in menu
organization).  These items are called "element labels". They may be
associated with a button (see Button specifications), and used in
the formatting functions (see Program variables).

   Here is the list:

_` '_
     An empty button

_Top_
     Top element. The associated name is `$TOP_HEADING' if that
     variable is defined. This variable is not set by default.

_Contents_
     Table of contents

_About_
     About (help) page

_Overview_
     Overview, short table of contents

_First_
     First element in reading order

_Last_
     Last element in reading order

_Index_
     The first chapter with `@printindex'. The associated name is  `$INDEX_CHAPTER',
     if the variable is set. This variable is not set by default.

_This_
     The current element

_Back_
     Preceding element in reading order

_FastBack_
     Beginning of this chapter or previous chapter if the element is a
     chapter

_Prev_
     Previous section on the same level

_NodePrev_
     Previous node

_Forward_
     Next element in reading order

_FastForward_
     Next chapter

_Next_
     Next section on the same level

_NodeNext_
     Next node

_Following_
     Next node in node reading order

_Up_
     Up section

_NodeUp_
     Up node

_FileNext_
     Forward element first in the next page (or file)

_FilePrev_
     Backward element first in the previous page (or file)

6.3 Customization of the navigation panels buttons
==================================================

A lot of customization of the navigation panel may be achieved without
redefining functions, with variables redefinition.  In case it isn't
enough, it is also possible to redefine the function doing the
navigation panel formatting.

6.3.1 Controlling the navigation panel panel at a high level
------------------------------------------------------------

The global formatting of the navigation panels may be changed with the
following variables:

`$VERTICAL_HEAD_NAVIGATION'
     A vertical navigation panel will be used for the header navigation
     panel if this variable is true.

`$ICONS'
     Icons are used instead of textual buttons if this variable is true.

`$SECTION_NAVIGATION'
     If this variable is false there is no section navigation, no
     navigation panels for the elements within the pages, only at the
     beginning and the end of the page (see Page layout options).

6.3.2 Specifying the buttons formatting
---------------------------------------

Several arrays and hashes enable a precise control on the buttons and
their display.  The following arrays determine the buttons present in
navigation panels:

`@SECTION_BUTTONS'
     This array is used for the navigation panel buttons present at the
     begining of sectioning elements. If split at node or section they
     are also used at the page footer, and in the case of section
     navigation at the page header.

`@SECTION_FOOTER_BUTTONS'
`@NODE_FOOTER_BUTTONS'
     This array is used for the navigation panel buttons present at the
     footer of pages when split at node or at section.

     If `$WORDS_IN_PAGE' is set and the output is split at nodes, these
     buttons are only present if there are more than `$WORDS_IN_PAGE'
     words in the sectioning element text. This counting is very rough
     and include punctuation marks, html elements, numbers.  The
     default is to include the buttons after 300 words.

`@CHAPTER_BUTTONS'
     This array is used for the buttons appearing at the page footer if
     split at chapter, and at the page header if split at chapter and
     there is no section navigation.

`@MISC_BUTTONS'
     These buttons appear at the beginning of special and sections and
     at the end of these section pages if the output is split.

`@LINKS_BUTTONS'
     These are used for `<link>' elements if they are output in the
     headers.

   The array specify the buttons displayed in navigation panels, and
how the button is displayed.  Each element is associated with a button
of the navigation panel from left to right.  The signification of the
array element value is the following:

_reference on a function_
     The function is called with argument a boolean true if the
     navigation panel should be vertical. Should return the formatted
     button text.

_reference on a scalar_
     The scalar value is printed. For some possibly usefull scalars,
     see Elements hashes.

_reference on an array_
     In this case the first array element should be a reference on text
     and the second element an element label. In that case a link to the
     element associated with the element label with the scalar value
     text is generated.

     For example if the buttons array element is
          [ 'Next', \$Texi2HTML::NODE{Next} ]

     The button will be a link to the next section with text `$Texi2HTML::NODE{Next}'.

_element label_
     If icons are not used, the button is a link to the corresponding
     element which text is defined by the value associated with the
     element label in the `%NAVIGATION_TEXT' hash, surrounded by `['
     and `]'. If the element label is ` ', there is no `[' and `]'.
     The element of the `%NAVIGATION_TEXT' hash are defined
     dynamically, in the `init_out' function reference (see Output initialization).

     If icons are used, the button is an image with file determined by
     the value associated with the element label in the `%ACTIVE_ICONS'
     hash if the the link really leads to an element, or in the `%PASSIVE_ICONS'
     hash if there is no element to link to. Of course if there is a
     link to the element the icon links to that element. The button
     name and the button description are used in HTML attributes to
     have a textual description of the icon. The corresponding strings
     are in `%BUTTONS_NAME'  for the button name and  `%NAVIGATION_TEXT'
     for the description.

   If `$USE_ACCESSKEY' is set, the `accesskey' attribute is used in
navigation. In that case the `%BUTTONS_ACCESSKEY' hash is used for the
access key.

   Similarly, if If `$USE_REL_REV' is set, the `rel' attribute is used
in navigation. In that case the `%BUTTONS_REL' hash is used for the rel
attribute.

6.3.3 Changing the navigation panel formatting
----------------------------------------------

If you are not satisfied with this scheme, it is possible to control
exactly the formatting of navigation panels by redefining a function
reference. The function controlling the display of navigation panel is
associated with the following function reference:

 -- Function Reference: $navigation_text print_navigation \@buttons
          $vertical
     \@BUTTONS is an array reference which should hold the
     specification of the buttons for that navigation panel. $VERTICAL
     is true if the navigation panel should be vertical.  Returns the
     formatted navigation panel in $NAVIGATION_TEXT.

6.4 Main program variables and usefull functions
================================================

In the functions controlling the page layout some global variables set
by the main program are available, with value corresponding with the
current layout element.

6.4.1 Accessing elements informations
-------------------------------------

Four hashes are available, with key the elements labels (as described
in Element labels) and values:

`%Texi2HTML::NAME'
     The formatted element name

`%Texi2HTML::HREF'
     The element hypertext reference

`%Texi2HTML::NODE'
     The element node name

`%Texi2HTML::NO_TEXI'
     The element name after removal of texi commands

   If `$USE_NODE_TARGET' is set, the node anchors are used as target
for the section HREF, if there is a node associated to that section.

6.4.2 Accessing global informations
-----------------------------------

Three kinds of global informations are available, miscalleneous global
strings, flags set by `@set' and special flags and section lines.

Global strings
..............

The `%Texi2HTML::THISDOC' hash holds some global informations:

`fulltitle'
     title set by `@settitle'. If there is no `@settitle' other
     possibilities are tried (`@title', `@shorttitlepage'...).

`fulltitle_no_texi'
     fulltitle without texi formatting

`fulltitle_texi'
     fulltitle with texi commands

`title'
     title set by `@title'.

`title_no_texi'
     title without texi formatting

`title_texi'
     title with texi commands

`author'
     Authors list set by `@author'.

`authors'
     A reference on an array containing each author set by `@author'.

`copying_comment'
     Text appearing in `@copying' with all the texinfo commands removed,
     put in comments.

`program'
     The name and version of `texi2html'.

`program_homepage'
     Homepage for `texi2html'.

`program_authors'
     Authors of `texi2html'.

`file_base_name'
     base name of the texinfo manual file.

`filename'
     This is a reference on a hash that holds the filenames for special
     elements.  These files may not be used in certain cases, for
     example the `toc' element file name may not be relevant if table
     of contents is not output separately.  The keys are
    `doc'
          the document file if not split, if split should be the top
          element file.

    `top'
          Top element file name.

    `toc'
          Table of contents element file name.

    `stoc'
          Overview (also called short table of contents) element file
          name.

    `about'
          About element file name.

    `foot'
          Footnotes element file name.

    `frame'
          Main frame file.

    `toc_frame'
          Table of contents frame file name.

`input_file_name'
     Name of the texinfo manual file given on the command line.

`destination_directory'
     Destination directory for the resulting files.

`extension'
     Extension for the output files.

`toc_file'
     The file name of the table of contents, should always be valid,
     even when table of contents are output directly in the document.

`inline_contents'
     A reference on a hash containing two key, one for each type of
     table of contents:
    `contents'
          The associated value is a reference on an array containg the
          line resulting from formatting the table of contents,
          including a heading and a reference.

    `shortcontents'
          The associated value is a reference on an array containg the
          line resulting from formatting the short table of contents,
          including a heading and a reference.

`today'
     The date. May be overriden by `$DATE'.

`user'
     The user running `texi2html'. Maybe overriden by `$USER'.

`css_import_lines'
     reference on an array containing the `@import' lines of CSS files.

`css_lines'
     reference on an array containing the normal lines of CSS files.

   It also holds the arg of the following commands, associated with the
command name: kbdinputstyle, paragraphindent, setchapternewpage,
headings, footnotestyle,  exampleindent, firstparagraphindent,
everyheading, everyfooting,  evenheading, evenfooting, oddheading,
oddfooting, setcontentsaftertitlepage, setshortcontentsaftertitlepage,
frenchspacing.  If the command doesn't have any arg, it will be true is
it was set.

Flags
.....

Flags defined by `@set' may be accessed through the `%main::value'
hash. The key is the flag name, the value is the flag value at the end
of the document.

   Special flags are set by the main program. They correspond with a
texinfo command, like `@setfilename', or `@settitle', `@author'... The
corresponding flag is the command name with `_' appended, for example,
`_titlefont' corresponds with `@titlefont'. Like other flags they are
available in `%main::value'.

Section lines
.............

The following array references or arrays holds formatted lines:

`$Texi2HTML::THIS_SECTION'
     Lines of the current element.

`$Texi2HTML::OVERVIEW'
     Lines of short table of contents. See Special pages.

`$Texi2HTML::TOC_LINES'
     Lines of table of contents. See Special pages.

`$Texi2HTML::TITLEPAGE'
     The title page formatted with special title commands (`@author',
     `@title') expanded. See Title page.

6.4.3 Function usefull in page formatting
-----------------------------------------

The usefull function is a function used to print an array of lines,
which also counts the number of words in the array, if needed.

 -- Function: $words_number main::print_lines $filehandle \@lines_array
     $FILEHANDLE is the opened filehandle the function should write to.
     \@LINES_ARRAY is the array line the function should write to the
     file.  If this argument is omitted, the function uses `$Texi2HTML::THIS_SECTION'.
     $WORDS_NUMBER is the number of words in the array, only defined if
     split at nodes and `$WORDS_IN_PAGE' is defined.

6.5 Preparing the output
========================

After the texinfo file has been parsed, some information is available
which can be used to modify some variables and prepare the outputting.
For example the document language, the document encoding, values set
with `@set' or `@setfilename' and other similar @-commands are not
known before the texinfo parsing.

   The following function reference may be redefined to be called after
texinfo processing and before document generation:

 -- Function Reference: init_out
     This function perform the initialization of variables and any other
     task before document outputting.

   In the default case the `$BODYTEXT' (see Customizing header) and
the hashes `%NAVIGATION_TEXT', `%BUTTONS_NAME'  (see Button specifications),
`%BUTTONS_GOTO' (see About text) are initialized.
Indeed the initialization of these variables is dependent upon the
document language selection. Similarly the encoding variables are set
based on the information now available (see Encodings).

   To perform the default initializations and also add more code, you
could do as in the following example (save the default function
reference and call it in your own function) :

     my $default_init_out = $init_out;
     $init_out = \&makeinfo_like_init_out;
     sub makeinfo_like_init_out()
     {
        &$default_init_out();
        $NAVIGATION_TEXT{'Following'} = ' &gt; ';
     }

6.6 Finalizing the output
=========================

If you want to do some cleaning after the document was generated (close
files, write at the end of files and so on), the following function
reference may be redefined:

 -- Function Reference: finish_out
     This function is called after the document generation.

   The default is to do nothing.

6.7 Customizing the `texi2html' css lines
=========================================

If the variable `$CSS_LINES' is set it is used for the css entries.
For example if you don't want any css entries, set

     $CSS_LINES = '';

   If this variable is `undef' (as in th edefault case), it is possible
to modify the `texi2html' css lines by modifying the entries or adding
to the `%css_map' hash. Each key is a css selector, the corresponding
value is a style string.

   Another possiblility is to modify the array corresponding with the
array reference `$Texi2HTML::THISDOC{'css_import_lines'}' that contains
the `@import' lines of CSS files, and similarly it is possible to
modify the array corresponding with the array reference
`$Texi2HTML::THISDOC{'css_lines'}'  that contains the normal CSS files
lines (for details on what corresponds with those different lines, see
HTML CSS (texinfo)).  The right place to modify these
arrays is in a function appearing in the `@command_handler_process'
array (see Bypassing normal formatting). Later, the CSS lines are
allready expanded, by the function reference below.

   In th edefault case, the resulting css lines are in `$Texi2html::THISDOC{'CSS_LINES'}'.
It is also possible to change completely the way
`$Texi2html::THISDOC{'CSS_LINES'}' are generated by redefining the
following function reference:

 -- Function Reference: css_lines \@import_lines \@rule_lines
     This function should be used to construct the variable
     `$Texi2html::THISDOC{'CSS_LINES'}'.  \@IMPORT_LINES are the
     `@import' lines of the files specified with `--include-css', and
     \@RULE_LINES are the css commands lines of these files.  See
     Style options.

6.8 Customizing the page header
===============================

It is possible to add lines to the text within the `<head>' HTML
elements, by defining the variable `$EXTRA_HEAD'.  Similarly it is
possible to add text just after the `<body>' element with the variable `$AFTER_BODY_OPEN'.
These variables are empty by default.

   The HTML encoding of the resulting document is defined by `$ENCODING_NAME'.
If the variable isn't defined, the `@documentencoding' value is used,
or the `$OUT_ENCODING' value, if set. `$ENCODING_NAME' may influence
the value of `$OUT_ENCODING', which corresponds with the encoding used
when writing to the resulting files.  See Encodings.

   The description of the document may be specified in `$DOCUMENT_DESCRIPTION'.
If this variable is undef, the text associated with
`@documentdescription' is used, and if there isn't such test a default
description is constructed using the document title and the name of the
first section of the file.  The value used during document formatting
is `$Texi2HTML::THISDOC{'DOCUMENT_DESCRIPTION'}'.

   The `<body>' element attributes may be set by defining the variable `$BODYTEXT'.
The resulting attributes are in `$Texi2HTML::THISDOC{'BODYTEXT'}'.  If
you want to define that variable dynamically, you should use the
`init_out' function reference (see Output initialization).

   `<link>' element are used in the header if `$USE_LINKS' is set. `@LINKS_BUTTONS'
determines which links are used.  `%BUTTONS_REL' determines the link
type associated with the `rel' attribute.

   The default functions call the function associated with `$print_head_navigation'
to format the navigation panel for the page header. Thus you can
control parts of the formatting by redefining the function reference.

 -- Function Reference: print_head_navigation $filehandle \@buttons
     $FILEHANDLE is the opened filehandle the function should write to.
     \@BUTTONS is an array reference which should hold the
     specification of the buttons for the navigation panel.

   If you want even more control, you can have full control over the
page header formatting by redefining three function references. The
function associated with `$print_page_head' is called for all the
pages, and after that, the function associated with `$print_chapter_header'
is called if the document is split at chapters, or the function
associated with `$print_section_header' is called if the document is
split at sections.

 -- Function Reference: print_page_head $filehandle
     $FILEHANDLE is the opened filehandle the function should write to.
     This function should print the page head, including the `<body>'
     element.

 -- Function Reference: print_chapter_header $filehandle
     $FILEHANDLE is the opened filehandle the function should write to.
     This function is called if the document is split at chapters, after
     `print_page_head'.

 -- Function Reference: print_section_header $filehandle
     $FILEHANDLE is the opened filehandle the function should write to.
     This function is called if the document is split at sections, after
     `print_page_head'.

6.9 Customizing the sections
============================

The functions associated with the following function references are
used for the formatting of sections:

 -- Function Reference: $element_header print_element_header
          $first_in_page $previous_is_top
     $FIRST_IN_PAGE is true if this section is the first section in the
     page.  $PREVIOUS_IS_TOP is true if this section is the section
     following the Top section.  This function should return
     $ELEMENT_HEADER, the current section header.

 -- Function Reference: print_section $filehandle $first_in_page
          $previous_is_top
     $FILEHANDLE is the opened filehandle the function should write to.
     $FIRST_IN_PAGE is true if this section is the first section in the
     page.  $PREVIOUS_IS_TOP is true if this section is the section
     following the Top section.  This function should print the current
     section contents.

 -- Function Reference: end_section $filehandle
          $last_element_or_before_top
     $FILEHANDLE is the opened filehandle the function should write to.
     $LAST_ELEMENT_OR_BEFORE_TOP is true if this section precedes the
     top element or is the last one in page, or before the special
     elements.

6.10 Customizing the page footer
================================

It is possible to add text just before the `</body>' element with the
variable `$PRE_BODY_CLOSE'. Nothing is added by default.

   A user name and  a date are collected to be output in the footer.
You can change them by defining `$USER' and `$DATE' in the
initialization file.

   The default functions call the function associated with `$print_foot_navigation'
to format the navigation panel for the page footer. Thus you can
control parts of the formatting by redefining the function reference.

 -- Function Reference: print_foot_navigation $filehandle \@buttons
     $FILEHANDLE is the opened filehandle the function should write to.
     \@BUTTONS is an array reference which should hold the
     specification of the buttons for the navigation panel.

   If you want even more control, you can have more control over the
page footer formatting by redefining three function references.  The
function associated with `$print_chapter_footer' is called if the
document is split at chapters, or the function associated with `$print_section_footer'
is called if the document is split at sections.   After that the
function associated with `$print_page_foot' is called.

 -- Function Reference: print_page_foot $filehandle
     $FILEHANDLE is the opened filehandle the function should write to.
     This function should print the page foot, including the `</body>'
     element.

 -- Function Reference: print_chapter_footer $filehandle
     $FILEHANDLE is the opened filehandle the function should write to.
     This function is called if the document is split at chapters,
     before `print_page_foot'.

 -- Function Reference: print_section_footer $filehandle
     $FILEHANDLE is the opened filehandle the function should write to.
     This function is called if the document is split at sections,
     before `print_page_foot'.

6.11 Special pages formatting
=============================

For the special elements, two things must be formatted: the content and
the page layout

6.11.1 Customizing the content of the special pages
---------------------------------------------------

The label for the special elements, except for the Top element is
formatted according to the function reference `$misc_element_label':

 -- Function Reference: $misc_element_label misc_element_label
          $identifier $page_name
     $IDENTIFIER is the identifier associated with the special element.
     $PAGE_NAME is the special element name. It should return a label
     that can be used for references to the special element.

6.11.1.1 Top element text formatting
....................................

The top element formatting is controlled by three function which also
controls the layout of the top element page or section. The associated
function references are:

 -- Function Reference: print_Top_header $filehandle $begin_page
     $FILEHANDLE is the opened filehandle the function should write to.
     $BEGIN_PAGE is true if the element is the first in a page.  This
     function should begin the Top element. At the time this function
     is called the top element text hasn't been parsed.

 -- Function Reference: print_Top $filehandle $has_top_heading
     $FILEHANDLE is the opened filehandle the function should write to.
     $HAS_TOP_HEADING is true if there is a `@heading' command or
     `@titlefont' command appearing in the Top element text.  This
     function should be used to format the Top element text and
     navigation panel.

 -- Function Reference: print_Top_footer $filehandle $end_page
     $FILEHANDLE is the opened filehandle the function should write to.
     $END_PAGE is true if the element is the last in a page.  This
     function should end the Top element.

6.11.1.2 Table of contents and Short table of contents
......................................................

Two possibilities exist for the formatting of table of contents (and
short table of contents). In the default case, the table of contents
are in separate elements, at the end of the document if the document is
unsplit or in separate files. This is consistent with `makeinfo' where
menus are used for navigation. Another mode may be selected by setting `$INLINE_CONTENTS'.
In that case the table of contents are not output as separate elements
but are instead output where the corresponding @-command, for example
`@contents', is set. This behaviour is more consistent with `texi2dvi'.
If `@setcontentsaftertitlepage' appears in the document, and even if
`$INLINE_CONTENTS' is set, the table of contents are merged in the
title (which isn't output in the default case, see Title page).

   Several variables may be used to control the formatting of table of
contents and short table of contents:

`$DO_CONTENTS'
     If the variable is true a table of contents is done even if there
     is no `@contents' command.  If it is defined and false, no table
     of contents is done even if there is a `@contents' command.

`$DO_SCONTENTS'
     If the variable is true a short table of contents is done even if
     there is no `@summarycontents' command.  If it is defined and
     false, no short table of contents is done even if there is a
     `@summarycontents' command.

`$BEFORE_OVERVIEW'
     The variable value is inserted before the short table of contents
     text.

`$AFTER_OVERVIEW'
     The variable value is inserted after the short table of contents
     text.

`$BEFORE_TOC_LINES'
     The variable value is inserted before the table of contents text.

`$AFTER_TOC_LINES'
     The variable value is inserted after the table of contents text.

`$NO_BULLET_LIST_STYLE'
     This should contain a css style used for the list style when there
     is no bullet.

`$NO_BULLET_LIST_ATTRIBUTE'
     This should contain an attribute text used for the list element
     when there is no bullet. For example it is used in the tables of
     if they are formatted with a list.

   More control on the table of contents and short table of contents
formatting may be achieved by redefining a function with the following
associated function reference:

 -- Function Reference: toc_body \@elements
     \@ELEMENTS is an array reference contining informations about all
     the elements of the document. Each of the entry of this array is
     an hash reference which entries correspond with different
     informations about the element. Interesting keys have the
     following meaning:

    `top'
          true if the element is the top element,

    `index_page'
          true if the element is an index page added because of index
          splitting,

    `toc_level'
          level of the element in the table of content. Highest level
          is 1 for the top element and for chapters, appendix and so on,
          2 for section, unnumberedsec and so on...

    `tocid'
          label used for reference linking to the element in table of
          contents,

    `file'
          the file containing the element, usefull to do href to that
          file in case the document is split,

    `text'
          text of the element, with section number,

    `name'
          text of the element, without section number.

     This function doesn't return anything but should fill the array
     corresponding with the `$Texi2HTML::TOC_LINES' and `$Texi2HTML::OVERVIEW'
     references with the table of contents and short table of contents.

   Another function reference is used to add a heading and a reference,
to be used with `$INLINE_CONTENTS' or merged in the title. Its output
is not used when the table of contents are separate elements.

 -- Function Reference: \ @inline_contents_lines inline_contents
          $filehandle $command $element
     This function reference returns a reference on an array holding
     the lines containing the contents, heading and reference.
     $FILEHANDLE is a reference on the currently opened file if the
     function is called because a `@contents' or `@shortcontents'
     command was encountered, it is undef otherwise.  $COMMAND is
     either `contents' or  `shortcontents'.  $ELEMENT is a hash
     reference containing informations about the table of contents
     context. Relevant keys are:
    `target'
          The identifier associated with the table of contents, used
          for example to do references to the table of contents using
          href in HTML.

    `id'
          The identifier associated with the element, used to do
          labels. In general the same than the `target', but not
          necessarily.

    `file'
          The file name containing the table of contents.

6.11.1.3 Formatting of footnotes text
.....................................

The footnotes text is allready formatting when `@footnote' commands are
expanded. See Footnotes.

6.11.1.4 Formatting of about text
.................................

The default about element contains an explaination of the buttons used
in the document (`@SECTION_BUTTONS', see Button specifications) and
an example locating the buttons targets in an example.  The formatting
of this text may be influenced by the following hashes and variables:

`$PRE_ABOUT'
`$AFTER_ABOUT'
     This variable may be a scalar or a function reference.  If it is a
     scalar, the value is used.  If this is a function reference it is
     expanded and the returned text is used. The text is added before
     or after the main about text.

`%BUTTONS_GOTO'
     The keys of this hash are element labels (see Element labels).
     The value is the text associated with the element label in the
     about text.  The element of the hash are defined dynamically, you
     should in the `init_out' function reference (see Output initialization).

`%BUTTONS_EXAMPLE'
     The keys of this hash are  element labels (see Element labels).
     The value is the text associated with the element label
     in the about example, typically a section number.

   If this is not enough and you want to control exactly the formatting
of the about text, you can redefine the function associated with the
following function reference:

 -- Function Reference: $about_text print_about
     This function should return the about text.

6.11.1.5 Formatting of title page
.................................

The title page is first formatted using the text appearing in the
`@titlepage' section, and put in `$Texi2HTML::TITLEPAGE'.  The
information appearing in `@title', `@subtitle' or `@author' is then
added using the following function reference:

 -- Function Reference: titlepage
     This function should complete `$Texi2HTML::TITLEPAGE'.

   In the default case, in this function the table of contents and short
table of contents are also added if they are to be output and
`@setcontentsaftertitlepage' or `@setshortcontentsaftertitlepage'
appear in the document (see Contents and Overview text).

   In the default case the resulting title page output is not used in
the document, except if the top node is not associated with any content.

6.11.2 Customizing the layout of the special pages
--------------------------------------------------

The formatting of each of the special pages, or section in case the
document is not split, is controlled by a function.  The associated
function reference is called accordingly:

`print_Top'

`print_Top_header'

`print_Top_footer'
     Formatting of top element page or section. It is also used for the
     formatting of the top element text (see Top element text).

`print_Toc'
     Formatting of table of contents page or section

`print_Overview'
     Formatting of short table of contents page or section

`print_About'
     Formatting of about (help) page or section

`print_Footnotes'
     Formatting of footnotes section or page in case footnotes are on a
     separated page or the document isn't split.

   In the default case, `$print_Top' calls `$print_Top_header' for the
header and `$print_Top_footer' for the footer of top element.  All the
other function call `$print_misc' which in turn calls `$print_misc_header'
for the headers and  `$print_misc_footer' for the footers.

6.12 Customizing the file and target names
==========================================

File names
----------

It is possible to specify the file names with more control than with the
command line options (see Output files).  First the extension may
be overrided by the variable `$EXTENSION' value. The variable should be
`undef' if no extension is to be added.  Two function references enable
further customization. One is usefull in case `$NODE_FILES' is true and
it is used to customize the node file name.

 -- Function Reference: $node_file node_file_name \%node
     \%NODE is a hash reference with the following interesting keys
     (there are much more keys):
    `texi'
          The texinfo node name.

    `with_section'
          True if associated with a section.
     The result is the node file name $NODE_FILE.

   The other is used to customize the file names associated with each
element, and the name of the file associated with the special elements.

 -- Function Reference: $file element_file_name \%element $type
          $docu_name
     \%ELEMENT is undefined for the special elements (about, overview,
     table of contents, footnotes).  Otherwise it is a hash reference
     with the following interesting keys (there are much more keys):
    `texi'
          The texinfo element name.

    `number'
          The number associated with a section.

    `doc_nr'
          A number incremented whenever a new file should begin, based
          on how the document is split (see Splitting output).

    `text'
          The element text.

    `name'
          The element text without section number.
     $TYPE is empty for normal elements.  For the top element it is
     `top', for the table of contents it is `toc', for the overview it
     is `stoc', for the footnotes it is `foot' and for about is
     `about'. If frames are used (see Page layout options), the
     function reference is also called for `frame', the frame file
     name, and `toc_frame' the table of content frame file name.
     $DOCU_NAME is the basename of the texinfo manual.  The result is
     the element or special element file name.

target names
------------

Similarly target and id may be set. The "id" is placed where the item
is located, the "target" is used to construct references to that item.
In general they should be equal, but not always, for example in the
default case, the target for a section is the node id.  The following
function reference, is for target items (nodes, anchors, floats):

 -- Function Reference: ($target,$id) node_target_name \%node,
          $default_target, $default_id
     \%NODE is the same as in the `node_file_name' function reference
     above.  $DEFAULT_TARGET is the target already set (it is also in
     `$node->{'target'}'), and $DEFAULT_ID is similarly the id already
     set.

   For element associated with files (which may be nodes), the function
reference is:

 -- Function Reference: ($target,$id) element_target_name \%element,
          $default_target, $default_id
     the \%ELEMENT is the same than in `element_file_name', and
     $DEFAULT_TARGET and $DEFAULT_ID are the target and id already set.

   Placed items (floats, footnotes, index entries, anchors, contents,
shortcontents and headings) file and target may also be set. In the
default case, they should be rightly set, so be careful when changing
them. The following function reference can be used:

 -- Function Reference: ($target, $id, $file) placed_target_file_name
          \%placed_item, \%element, $default_target, $default_id,
          $default_file, $context
     \%PLACED_ITEM is a hash reference describing the placed item, in
     the same vein than above.  the \%ELEMENT is the same than in
     `element_file_name', corresponding with the element containing the
     placed item.  $DEFAULT_FILE, DEFAULT_ID and $DEFAULT_TARGET are
     the file, id and target already set.  $CONTEXT describes the
     context, it is empty in the normal cases, and can also be set to
     `footnotes' if in footnotes, or to `no_associated_element' if the
     placed item is out of any element (typically in `@titlepage',
     `@copying').

   For special elements, the `%misc_pages_targets' hash is used to set
the target and id. The possibilities for the keys are `Overview',
`Contents', `Footnotes' and `About'.

6.13 Generation of external files for index entries
===================================================

Within the document, `@printindex' commands are expanded as explained
in Index list. In case you want to do something special with
index entries, outside of the document, you should first set the
variable `$IDX_SUMMARY' true. After that some function reference will
be called for each non empty index. For each index there are 3 function
references, one called for initialization, one called for each index
entry and the last one called for finalization.

 -- Function Reference: index_summary_file_begin $index_name
          $is_printed $manual_name
     $INDEX_NAME is the two letters name for the index.  This function
     is called for each index appearing in the document, before
     `index_summary_file_entry'.  $IS_PRINTED is true if there is a
     `@printindex' for that index.  $MANUAL_NAME is the manual basename.

 -- Function Reference: index_summary_file_entry $index_name
          $entry_text $entry_reference $formatted_entry $texi_entry
          $entry_element_reference $entry_element_header $is_printed
          $manual_name
     This function is called for each entry of an index. INDEX_NAME is
     the name of the index. $ENTRY_TEXT is the entry in plain text,
     $FORMATTED_ENTRY is the index entry formatted, $TEXI_ENTRY is the
     entry with texinfo commands. $ENTRY_REFERENCE is the reference
     placed at the index entry place, in the form `file#id'.
     $ENTRY_ELEMENT_HEADER is the formatted header of the element
     containing the index entry. ENTRY_ELEMENT_HEADER is the reference
     to the beginning of the element containing the index entry, in the
     form `file#id'.  $IS_PRINTED is true if there is a `@printindex'
     for that index.  $MANUAL_NAME is the manual basename.

 -- Function Reference: index_summary_file_end $index_name $is_printed
          $manual_name
     $INDEX_NAME is the two letters name for the index. This function
     is called for each index appearing in the document, after
     `index_summary_file_entry'.  $IS_PRINTED is true if there is a
     `@printindex' for that index.  $MANUAL_NAME is the manual basename.

7 Customizing HTML and text style in init files
***********************************************

Some simple customization may be achieved with the redefinition of the
variables associated with the command line options. For the description
and an explanation of the meaning of these variables, see Style options.

   Other variables and hash entries can be modified in initialization
file to achieve more customization.  Lastly, functions references
corresponding with functions called from the main program and
initialization files may be redefined.

7.1 Three contexts for expansions: preformatted, normal and string
==================================================================

There are three contexts of interest, one is the normal context, the
other is a special context, called the "preformatted" context and the
last is the string context. The preformatted context occurs when the
spacing between words is kept. This is the case, for example, in
`@display' or `@example' regions, and in menu comments (see Menus).
The preformatted regions are usually rendered in `<pre>' elements in
HTML.  The string context occurs when rendering strings without
formatting elements, in comments or titles for example.

7.2 Three passes: macro expansion, document structure and output
================================================================

There are three passes in `texi2html'. During pass 0, the `@macro' are
expanded, in pass 1 the document structure is gathered and in pass 2
the result is output. In most cases you shouldn't care about it, as
almost all of the output customization is done in pass 2.  Only if you
want to do something before the pass 2 should you care.

7.3 Customizing the formatting of commands without argument
===========================================================

This includes the commands whose name is a nonletter character like
`@@', the commands with lettered characters and braces but whose braces
should be empty, like `@TeX{}', or some commands associated with
accentted letters like `@AA{}'. If there happens to be something within
the braces, it is put after the command, thus
     @TeX{something}
   leads to the same than
     @TeX{} something

   Each of these categories of commands have three associated hashes,
one for normal context, the other for preformatted context and the last
in strings. The keys of the hashes are the command names, the
associated value is the text replacing the command.

   The hashes are:
command type                normal text   preformatted text   string
one nonlettered character   `%simple_map' `%simple_map_pre'   `%simple_map_texi'
nothing in braces           `%things_map' `%pre_map'          `%texi_map'

   To change the HTML resulting from these constructs, just change the
value. For example, if you want `&shy;' to be outputted for `@-' in
normal and preformatted context, write in your init file:

     $simple_map{'-'} = '&shy;';
     $simple_map_pre{'-'} = '&shy;';

7.4 Punctuation commands
========================

The formatting of a punctuation character followed by `' is determined
by the hash `%colon_command_punctuation_characters'. If a `' command is
preceded by a character in th is hash, it is replaced by the associated
value. In the default case, the associated value is also the character,
so this leave the punctuation character unmodified.

   The following function reference may be redefined to handle
characters that are in `%colon_command_punctuation_characters':

 -- Function Reference: $punctuation $colon_command $character
     The $CHARACTER is a character appearing in
     `%colon_command_punctuation_characters' and preceding a `'
     command. In the default case the associated value in
     `%colon_command_punctuation_characters' is returned.

7.5 Customizing accent, style and other simple commands
=======================================================

The formatting of the HTML produced by style and indicatric commands
(`@tt', `@code', `@email', `@titlefont'), the accentuation related
commands taking argument (`@'', `@udotaccent', `@dotless') and
miscalleneous commands (`@email', `@verb', `@w', `@uref', `@math',
`@asis') is controlled by two hash in the default case, `%style_map'
for normal context, `%style_map_pre' for preformatted context and `%style_map_texi'
in string context.

   The key of the hashes are the command names. There are two
possibilities for the values corresponding with two interfaces. The
values may be strings or hash references, and you can chose the
interface depending on the one you prefer. The interface with hash
reference is a bit more flexible but might also be regarded as more
complex. If you don't like either of these interfaces you can define
your own.

   Some remarks are in order:

   * The nonlettered accent commands which following character is
     considered to be the argument (like in `@`a') should be keys of the
     hash `%accent_map' hash, even if no value is associated.

   * `@math' is handled differently if LaTeX2HTML is used.

7.5.1 An interface for commands formatting with a hash reference
----------------------------------------------------------------

The key of the hashes are the command names. The value determine how
the command argument is formatted. This value is a reference on a hash.
In this hash each key corresponds with a type of information for the
formatting, and the value is the corresponding information. For
example, in

     $style_map{'command'} = { 'args' => ['code'], 'attribute' => 'code'};

   the arguments for `@command' are interpreted as specified by the
values associated with the `args' key while the attribute associated
with that command is `code'.

   The following keys in the hashes associated with each command have
the following meaning:

`args'
     The value associated is a reference on an array. Each element of
     the array defines how the arguments (separated by `,' in the
     texinfo code) for the @-command should be formatted. The
     possibilities are
    `normal'
          for normal text,

    `code'
          for text with `---', `--', `''' and  ```' kept as is,

    `keep'
          if the texinfo should be kept as is, without interpretation
          of the @-commands.

     For example, we have
          $style_map{'email'}->{'args'} = ['code', 'normal'];

     because `---', `--', `''' and  ```' should be kept as is in the
     first argument of `@email'.

     The default is `['normal']'.

`attribute'
     If the associated value is a word, it is considered to be an HTML
     element name, and the argument is enclosed between the element
     opening and the element closing. For example, if the value is
     `elem', the resulting HTML is `<elem>ARG</elem>'.

     If the text is a word followed by some text, the word and is
     interpreted as above, and the text is considered to be the
     attributes text of the element.  Thus `elem class="elem"' leads to
     `<elem class="elem">ARG</elem>'.

     This works only if there is only one argument.

`begin'
     The associated value is added in front of the text.

`begin'
     The associated value is added after the text.

`quotes'
     If the corresponding value is true, the result is enclosed in
     quotes `$OPEN_QUOTE_SYMBOL' and `$CLOSE_QUOTE_SYMBOL', with
     defaults ``' and `''.

`function'
     The corresponding value should be a function reference. The
     corresponding function is called with the following arguments:

    `$command'
          The @-command name

    `$args'
          A reference on an array containing the arguments of the
          @-command.

    `$command_stack'
          A reference on an array containing the name of the @-commands
          containing the @-command being formatted, latest on top.

    `$state'
          A reference on a hash containing a lot of informations about
          the context of the @-command.

    `$line_nr'
          An opaque structure containing the information about the line
          number of the @-command. It can be used to call
          `main::echo_error' or `main::echo_warning' with first
          argument a message, and second argument `$line_nr'.

7.5.2 An interface for commands formatting with a string
--------------------------------------------------------

The keys of the hashes are the command names. The value determine how
the command argument is formatted. If the value begins with `"', the
result is enclosed in quotes `$OPEN_QUOTE_SYMBOL' and `$CLOSE_QUOTE_SYMBOL',
with defaults ``' and `''.

   The command argument is allready formatted as HTML.  The remaining
of the value text (or the value text if there were no `"') is
interpreted as follow:

   * If the text is empty the argument of the command is left as is.

   * If the text is a `&' followed by a name, like `&function', the
     name is considered to be a function name, and this function is
     called to format the argument of the command. The first argument
     of the function is the command name, the second is the command
     argument. For example, if the value associated with the
     (fictituous) command `@foo' is `&my_func' and we have:

          sub my_func
          {
              my @args = split /,\s*/ $_[1];
              return "$_[0]: $args[0]" if ($args[1] = 1);
              return "$args[0]";
          }

     The result of
          @foo{truc, 1}
          @foo{truc, bidule}
     will be
          foo: truc
          truc

   * If the text is a word, it is considered to be an HTML element
     name, and the argument is enclosed between the element opening and
     the element closing. For example, if the value is `elem', the
     resulting HTML is `<elem>ARG</elem>'.  Similarly `"quoted' leads to
     ``<quoted>ARG</quoted>''.

   * If the text is a word followed by some text, the word and is
     interpreted as above, and the text is considered to be the
     attributes text of the element.  Thus `elem class="elem"' leads to
     `<elem class="elem">ARG</elem>'.

7.5.3 Defining the style and indicatric commands interface
----------------------------------------------------------

If you don't like this scheme, it is possible to change how those
commands are processed by redefining the following function reference:

 -- Function Reference: $resulting_text style $style $command $text
          $args $no_close $no_open $line_nr $state $command_stack
     $COMMAND is the @-command, $STYLE is the value associated with the
     $COMMAND in the `%style_map', `%style_map_pre' or
     `%style_map_texi' hashes.  The $TEXT is the text appearing within
     the @-command braces.  ARGS is a reference on an array contening
     the command arguments formatted according to the same conventions
     than with the reference hash style (provided the value associated
     with the @-command is a hash reference with a $ARG key as
     described in Reference hash args).  If $TEXT is split in
     paragraphs each paragraph is passed through the function, and
     $NO_CLOSE is true if it is not the last paragraph, while $NO_OPEN
     is true if it is not the first paragraph.  $LINE_NR is an opaque
     structure containing the information about the line number of the
     @-command. It can be used to call `main::echo_error' or
     `main::echo_warning' with first argument a message, and second
     argument `$line_nr'.  $STATE is a reference on a hash containing a
     lot of informations about the context of the @-command.
     $COMMAND_STACK is a reference on an array containing the name of
     the @-commands containing the @-command being formatted.

7.6 Formatting of special simple commands
=========================================

The formatting of special simple commands is controlled by functions. To
customize the output, the corresponding function references should be
redefined. All these functions return a formatted text.

   The formatting of anchors is controlled by `$anchor_label'.

 -- Function Reference: $anchor_label anchor_label $identifier $anchor
     $IDENTIFIER is the anchor identifier, $ANCHORis the `@anchor'
     argument.

   In the default case, it uses a function reference,  `$anchor'  that
can do a reference target or link. It is especially relevant for HTML
but can be used in other formats, it is a rather common element of
different formats.

 -- Function Reference: $anchor anchor $identifier $href $text
          $attributes
     If $IDENTIFIER is not empty, this value should be used to create a
     target for links (typically associated with a name or id attribute
     in HTML).  The $HREF argument specifies a hpertextual reference
     which should be used to link to a target.  In case both
     $IDENTIFIER and  $HREF are given the text produced should be both
     a target for $IDENTIFIER and a link to $HREF.  $TEXT is the text
     to be displayed.  $ATTRIBUTES are additional attributes.  It
     should be reasonable to assume that the attributes are for a `<a>'
     HTML element.

   To customize the images produced by `@image', the first possibility
is to modify the `@IMAGE_EXTENSIONS', which holds a list of filename
extensions for image files. It is also possible to redefine the
function used to determine the filename of the image:

     Warning: This description is wrong. The API is still moving, so
     don't count on it.

 -- Function Reference: $filename image_files $basename $extension
     $BASENAME is the first `@image' argument, $EXTENSION is the
     corresponding `@image' argument. This function reference should
     return an array of image filenames without path that the main
     program should look for.

   Last, it is possible to control the formatting of `@image' by
redefining:

 -- Function Reference: $image image $file_path $basename $preformatted
          $file_name $alt_text $width $height $raw_alt $extension
          $working_dir $file_relative_path
     $FILE_PATH is the image file name with the path from the output
     directory to the source manual directory prepended, $BASENAME the
     file name without extension (the first `@image' argument).
     $PREFORMATTED is true if the image appears in preformatted text.
     $FILE_NAME is the file name without path but with extension.
     $ALT_TEXT is the alternate text, it may be undefined. $WIDTH and
     $HEIGHT are the corresponding arguments of `@image', $RAW_ALT is
     the unmodified alt argument of `@image' and $EXTENSION holds the
     corresponding `@image' argument.  $WORKING_DIR is the path to
     working dir relative to the output directory. $FILE_RELATIVE_PATH
     is the file name relative to the $WORKING_DIR.

   The formatting of `@sp' is controlled by:

 -- Function Reference: $sp sp $number $preformatted
     $NUMBER is the numeric argument of `@sp'.  $PREFORMATTED is true
     if the `@sp' appears in preformatted text.

   The formatting of `@acronym' and `@abbr' is controlled by:

 -- Function Reference: $acronym acronym_like $acronym_texi
          $acronym_text $with_explanation \@explanation_lines
          $explanation_text $explanation_simply_formatted
     $ACRONYM_TEXI is the acronym argument with texinfo @-commands,
     $ACRONYM_TEXT is formatted.

     The other arguments are related with the explanation, the second
     arg of the acronym. $WITH_EXPLANATION is true if the second
     argument of the acronym command is present. If an explanation
     exists, coming from previous `@acronym' or as an arg of this
     command, the other args are defined: \@EXPLANATION_LINES is a
     reference on an array containing the simply fomatted explanation
     lines, $EXPLANATION_TEXT is the explanation text formatted,
     $EXPLANATION_SIMPLY_FORMATTED is the explanation with a light
     formatting, unabling in HTML (or XML) the explanation to be in an
     attribute.

7.7 Processing special characters in text
=========================================

Some characters are processed especially in text: `---', `--', ```' and
`'''. This is done only if in normal text and not in some commands
(`@code', `@env'...). A function reference is called to process the
text and should take care of those constructs.  It may also be used to
transform the text, for example set it in upper case if it is in `@sc'.
This function should also take care of protecting special characters

 -- Function Reference: $processed_text normal_text $text $in_raw_text
          $in_preformatted $in_code $in_simple $command_stack
     The function processes $TEXT and returns $PROCESSED_TEXT.  The
     other arguments give some information about the context of the
     text.  $IN_RAW_TEXT is true if the text appears in special place
     where there is no formatting, typically in comments.
     $IN_PREFORMATTED is true if in a preformatted environemnt, and
     $IN_CODE is true if in a special command like `@code', `@env' where
     `---', `--', ```' and `''' should not be touched. $IN_SIMPLE is
     true if in string context.   $COMMAND_STACK is an array containing
     the name of the formatting @-command that enclose the text.

     In the default case the `---', `--', ```' and `''' constructs are
     expanded if needed and the text is upper-cased if in `@sc'.
     Special characters (`&', `"', `<' and `>' in HTML) are protected
     if needed.

   Some characters are special, for example we have  `&', `"', `<' and
`>' in HTML. In some cases some pieces of text don't go through the
above function, but still needs to be protected to appear in text.
This is done by the function associated with the function reference

 -- Function Reference: $protected_text protect_text $text
     The function processes the unprotected text $TEXT and returns the
     resulting protected text $PROTECTED_TEXT.

   Empty lines are processed by the following function reference, which
could be usefull if empty lines are to be removed for example

 -- Function Reference: $resulting_text empty_line $empty_line $state
     This function processes an $EMPTY_LINE and returns the resulting
     text $RESULTING_TEXT. $STATE is a structure that holds informations
     about the state of the parsing.  Empty lines are left as is by
     default except right after a definition @-command.

7.8 Customizing strings written by `texi2html'
==============================================

`texi2html' writes some strings in the generated document at various
places, at the page footers, on the help page, for special section
headings, buttons alt text and so on. These strings are customizable.
The string chosen depends on the language of the document (set by `--document-language', `$LANG'
or `@documentlanguage'). This is the basis for internationalization as
it allows for strings translations.

   The strings are found in a hash reference, `$LANGUAGES'.  Each key
is a language code. The associated value is also a hash reference. The
key is an english string and the associated value is the string
replacing the english string, if present. For example, we have

     $LANGUAGES->{'fr'} = {
                   ' Up ' => 'Plus haut',
     };

   It means that whenever the string ` Up ' is to be written and the
language is `fr', `Plus haut' is written. It is possible to customize
the english strings by redefining the `en' language hash.

   When a string contains a `%' followed by `{' NAME `}' it means that
the string will be expanded by `texi2html'. For example, if we have

     $LANGUAGES->{'fr'} = {
                   'See %{node_file_href}' => 'Voir %{node_file_href}',
     };

   `%{node_file_href}' will be expanded to an href for a node in a file
by `texi2html' in the string. A `%%' will be expanded as `%'.

   When a `@documentlanguage' appears in the document and the language
wasn't set on the command line, it may be convenient for the user to
redefine some variables based on the new language. There is a function
reference that may be used for that, it is called each time  a
`@documentlanguage' is encountered:

 -- Function Reference: $translate_names
     This function is called each time `@documentlanguage' is
     encountered and the language wasn't seet on the command line. It
     should be used to retranslate some strings based on the new
     language.

   For more on internationalization, see Internationalization.

7.9 References
==============

7.9.1 Reference to external manual
----------------------------------

The references are produced with two function references, one for the
hypertextual reference construction, the other for the full reference to
external manual.

 -- Function Reference: $href external_href $node $node_identifier
          $xml_node_identifier $manual_file_name
     $NODE is the node name, with @-commands. $NODE_IDENTIFER is the
     node name mapped to an identifier acceptable as a file name.
     $XML_NODE_IDENTIFIER is the node name mapped to an identifier
     acceptable as an XML identifier.  Those identifiers are built as
     explained in HTML Xref (texinfo), thus allowing
     for cross references to external manuals. $FILE is the manual or
     file name of the external reference. This function should return an
     href leading to the external manual.

     The default for this function is to make a reference compatible
     with `makeinfo'  (see HTML Xref (texinfo)).

 -- Function Reference: $text external_ref $command $section $book
          $node_and_file $href $cross_ref_name \@args_texi
          \@formatted_args
     This function formats a reference to an external texinfo manual.
     The $COMMAND is the ref command (`ref', `xref' or `pxref', in
     text, at sentence beginning or in parenthesis).  The optionnal
     $SECTION argument is the section in the book and  BOOK is the book
     title.  $NODE_AND_FILE is the node and file name formatted
     according to the convention used in info: `(file)node'. $HREF it
     an hypertextual reference to the distant manual constructed using
     the above function.  $CROSS_REF_NAME is an optionnal cross
     reference name appearing in the reference command.  \@ARGS_TEXI is
     a reference on an array containing the @-command arguments, not
     formatted, with \@FORMATTED_ARGS contains the formatted @-command
     arguments.  This function returns the text corresponding with the
     external html manual reference.  This function returns the full
     formatted text of the external reference.

7.9.2 Reference to an internal node
-----------------------------------

A function reference is available for internal references.

 -- Function Reference: $text internal_ref $command $href $short_name
          $name $is_section \@args_texi \@formatted_args
     This function formats a reference to a node in the current manual.
     The $COMMAND is the ref command (`ref', `xref' or `pxref', in
     text, at sentence beginning or in parenthesis).  $HREF it an
     hypertextual reference linking to the corresponding node or
     section. $SHORT_NAME and $NAME hold the text for the reference but
     $SHORT_NAME can be the node name which is assumed to be shorter
     than the section name.  $IS_SECTION is a boolean true if the
     reference is a reference to a section.  \@ARGS_TEXI is a reference
     on an array containing the @-command arguments, not formatted,
     with \@FORMATTED_ARGS contains the formatted @-command arguments.
     This function returns the full formatted text of the internal
     reference.

7.10 Commands used for centering and flushing of text
=====================================================

When a command controlling the alignement of text is used (`@center',
`@flushleft' and `@flushright'), the main program takes care of opening
and closing paragraphs. The alignement commands are the key of the `%paragraph_style'
hash.  The value is used in the function doing the formatting of the
paragraphs.  See Paragraph and preformatted region.

   A function references allows for a customization of the formatting
of the text appearing in the command block.

 -- Function Reference: $result paragraph_style_command $command $text
     $COMMAND is the command name, $TEXT is the text appearing within
     the command. This function returns a formatted text.  The default
     is to return the text unmodified.

7.11 Formatting (or not) a paragraph and a preformatted region
==============================================================

7.11.1 Paragraph and preformatted region formatting
---------------------------------------------------

The formatting of a paragraph region or a preformatted region, is
controlled by function references:

 -- Function Reference: $paragraph_text paragraph $text $alignement
          $index $formatting_command $formatting_command_formatted
          \$paragraph_number $format $item_number $enumerate_style
          $number $command_stack_at_end $command_stack_at_begin
     This function formats a paragraph. $TEXT is the text of the
     paragraph, $ALIGNEMENT is the empty string when no alignement
     command has been seen, otherwise it is the current alignement
     command name.  See Alignement commands.  $INDENT holds
     `noindent' or `indent' if the corresponding @-command appeared in
     the paragraph.  $COMMAND_STACK_AT_END and $COMMAND_STACK_AT_BEGIN
     are arrays containing the opened @-commands at end and at
     beginning of the paragraph, latest on top.

     The remaining arguments are usefull when the paragraph appears
     within a list or table. It is usefull whenever the paragraph has
     to be formatted differently when appearing in such environments.
     Moreover in that case the format command (`@itemize'...)  may have
     an associated formatting command.  $FORMATTING_COMMAND is this
     formatting command (like `@minus').  $FORMATTING_COMMAND_FORMATTED
     is the command formatted in html in case the formatting command is
     a leading command (like `@minus') which should be leading the
     first paragraph.  \$PARAGRAPH_NUMBER is a reference on the number
     of paragraphs in that format command. The corresponding variable
     should be increased when a paragraph is added. $FORMAT is the
     format command.  See Table and list items.

     If the $FORMAT is an enumerate, $ITEM_NUMBER is the number of the
     item in the list, $ENUMERATE_STYLE is the argument of the
     enumerate, $NUMBER is the number or letter corresponding with this
     item.

 -- Function Reference: $preformatted_text preformatted $text $style
          $region_name $formatting_command
          $formatting_command_formatted \$preformatted_number $format
          $item_number $enumerate_style $number $command_stack_at_end
          $command_stack_at_begin
     This function formats a preformatted region. $TEXT is the text of
     the preformatted region, $STYLE is the css style associated with
     that preformatted region (see css). $REGION_NAME is the name
     of the command opening the preformatted region (`example'..., see
     Complex formats) or a identifier for the preformatted
     context (for example `menu-comment', see Menus).  The
     alignment commands are not taken into account, as the spaces are
     preserved in preformatted regions, you should flush and center by
     hand.  $COMMAND_STACK_AT_END and $COMMAND_STACK_AT_BEGIN are arrays
     containing the opened @-commands at end and at beginning of the
     preformatted region, latest on top.

     The remaining arguments are usefull when the preformatted region
     appears within a list or table. It is usefull whenever the
     preformatted region has to be formatted differently when appearing
     in such environments.  Moreover in that case the format command
     (`@itemize'...)  may have an associated formatting command.
     $FORMATTING_COMMAND is this  formatting command (like `@minus').
     $FORMATTING_COMMAND_FORMATTED is the command formatted in html in
     case the formatting command is a leading command (like `@minus')
     which should be leading the first preformatted region.
     \$PREFORMATTED_NUMBER is a reference on the number of preformatted
     regions in that format command. The corresponding variable should
     be increased when a preformatted region is added. $FORMAT is the
     format command.  See Table and list items.

     If the $FORMAT is an enumerate, $ITEM_NUMBER is the number of the
     item in the list, $ENUMERATE_STYLE is the argument of the
     enumerate, $NUMBER is the number or letter corresponding with this
     item.

7.11.2 Avoiding paragraphs in formats
-------------------------------------

It is possible to avoid that a format closes the previous paragraph or
preformatted region and reopens one, by putting the format command in a
hash, `%format_in_paragraph' with a true value. This only makes sense
for few commands since otherwise the nesting of formats and paragraphs
could become wrong.

   If the value of `%no_paragraph_commands' associated with a command is
true, no paragraph is started by the command if outside of a paragraph
(after an empty line, for example). If the value is set to 0, it will
start a paragraph. If the value is not set, reasonable defaults are set.

   It is also possible to stop a paragraph when an @-command happens by
putting the @-command in the `%stop_paragraph_command' hash associated
with a true value.

7.12 Formatting of complex formats (`@example', `@display'...)
==============================================================

Here we see how a whole complex format is formatted. For the formatting
of the text, see Paragraph and preformatted region.

   The formatting of the complex formats is ultimately controlled by a
function, however the default for this function uses a hash reference
and changing the hash reference values should be enough in most cases.
This hash reference is called `$complex_format_map'. It has a key for
each of the complex format commands (`example', `smallexample', `lisp',
`smalllisp', `display', `smalldisplay', `format', `smallformat').

   The associated value is also a reference on a hash. The keys are:

`begin'
     An eval of `begin' should lead to the beginning of the formatted
     HTML.

`end'
     An eval of `end' should lead to the end of the formatted HTML.

`class'
     The HTML class. If not defined, the command name.

`pre_style'
     The preformatted style. If not defined the corresponding CSS style
     is used.

`style'
     If the associated value is `code', the format is assumed to be in
     code style, where with `---', `--', `''' and  ```' kept as is.  If
     the key is absent the format  inherits the code style and the font
     from the enclosing context.
   The enclosed text will be formatted as described in Paragraph and preformatted region,
and the name of the complex format will be
available to the function formatting the text.

   If you aren't satisfied with this scheme, you can redefine the
following function reference for a better control over the complex
format formatting:

 -- Function Reference: $complex_format_text complex_format
          $format_name $preformatted_text
     $FORMAT_NAME is the complex format name, $PREFORMATTED_TEXT is the
     text allready formatted as described in Paragraph and preformatted region.
     This function returns the whole complex
     format.

7.13 Customizing the formatting of lists and tables
===================================================

The formatting of lists and tables is done at two levels:
   * At the level of the whole region (table or list),

   * At the level of the individual items, rows or cells of the list or
     table.

7.13.1 Formatting individual table and list items
-------------------------------------------------

In texinfo it is possible to give `@itemize' or table command (hereafter
called a "format command") a "formatting command".  For example
`@minus' is the formatting command here:
     @table @minus

   The default is to apply the command to the text item, however it is
possible to avoid it.  The hash `%special_list_commands' has an entry
for each of the format command. Each of these entries is a hash
reference. If a formatting command is a key of the hash reference, then
the formatting command is not applied to the text item for that format
command. For example, if we have:

     $special_list_commands{'itemize'} = { 'bullet' => '' };

   and we have the following `@itemize':
     @itemize @bullet
     @item an item
     @end itemize

   then `@bullet' will not be applied to `an item'.

   More control of the text before formatting of the line or the item is
achieved with the following function reference:

 -- Function Reference: ( $result_line, $open_command)
          format_list_item_texi $format $line $prepended $command
     The $FORMAT is the list or table @-command, $LINE is the item
     line, $COMMAND is the "format command", $PREPENDED is set to the
     text folllowing the "format command" on the format argumlent line.
     The $RESULT_LINE replaces the item argument, and if $OPEN_COMMAND
     is true, the "format command" is opened for the line.

_lists_
     The items of lists are formatted using the following function
     reference:

      -- Function Reference: $list_item list_item $text $format
               $command $formatted_command $item_number
               $enumerate_style $number $prepended_texi
               $prepended_formatted
          This function formats the text between `@item' commands. $TEXT
          is the text corresponding with the item. $FORMAT is the type
          of format, `itemize' or `enumerate'. $COMMAND is the
          formatting command given in argument to `@itemize',
          $FORMATTED_COMMAND is this command formatted if it is a
          leading command, like `@minus'.

          If the $FORMAT is an enumerate, $ITEM_NUMBER is the number of
          the item in the list, $ENUMERATE_STYLE is the argument of the
          enumerate, $NUMBER is the number or letter corresponding with
          this item.

          If the $FORMAT is an itemize, $PREPENDED_TEXI is the text that
          appeared on the itemize line, maybe after the formatting
          command (if any), and $PREPENDED_FORMATTED is the
          corresponding text, formatted.

_two column tables_
     The two columns tables (`@table', `@ftable' and `@vtable'), items
     are formatted using two function references, one for the first
     line located on the `@item' line corresponding with the first
     column, the other for the text appearing on the following lines,
     corresponding with the second column text.

      -- Function Reference: $table_item table_item $item_text
               $index_label_text $format $command $formatted_command
               $command_stack $text_formatted
               $text_formatted_leading_spaces
               $text_formatted_trailing_spaces $item_command
          This function is used to format the text on the `@item' line.
          $TEXT_ITEM is the text line. In case there is an index entry
          associated with the `@item' (as with `@ftable' and
          `@vtable'), $INDEX_LABEL_TEXT is the text inserted at the
          place where an index entry appears. See Index entry place.
          $FORMAT is the type of format, `table', `ftable' or `vtable'.
          $COMMAND is the formatting command given in argument to the
          table format command, $FORMATTED_COMMAND is this command
          formatted if it is a leading command, like `@minus'.
          $COMMAND_STACK is an array with all the @-commands opened,
          latest on top.  $TEXT_FORMATTED is the text formatted by the
          formatting command if the command is a command with braces
          like `@code'.  $TEXT_FORMATTED_LEADING_SPACES and
          $TEXT_FORMATTED_TRAILING_SPACES are the spaces removed before
          closing the format.  $ITEM_COMMAND is the item command,
          `@item' or `@itemx'.

      -- Function Reference: $table_line table_line $text
          This function is used to format the text on the lines
          following the `@item' line. $TEXT is the corresponding text.

_multitable_
     The multitable elements formatting is controlled by the functions
     associated with two function references. One for a cell, and the
     other for a row.

      -- Function Reference: $multitable_cell cell $text $item_command
               \@columnfractions \@prototype_row \@prototype_lengths
               $column_number
          This function is used to format the text of a multitable
          cell, the text following a `@item' or a `@tab'.  $TEXT is the
          corresponding text. $ITEM_COMMAND is the command used to
          introduce the row, such that it is possible to distinguish
          between `@item' and `@headitem'.  \@COLUMNFRACTIONS is a
          reference on an array containing the `@columnfraction'
          arguments, if any, and \@PROTOTYPE_ROW is a reference on an
          array containing the row prototypes given on the
          `@multitable' line, if any.  \@PROTOTYPE_LENGTHS array
          contains the lengths of the row prototypes formatted.
          $COLUMN_NUMBER is the maximal number of columns.

      -- Function Reference: $multitable_row row $text $item_command
               \@columnfractions \@prototype_row \@prototype_lengths
               $column_number
          This function is used to format a multitable row. $TEXT is
          the row text, with cells allready formatted with the `$cell'
          function reference. $ITEM_COMMAND, \@COLUMNFRACTIONS,
          \@PROTOTYPE_ROW, \@PROTOTYPE_LENGTHS and $COLUMN_NUMBER are
          the same than in the function reference above.

   In the default case, this function is interlinked with
`$begin_format_texi' (see Customizing format opening) and
`@multitable' formatting since a stack of possible nested multitables
is kept to know the cell number.

7.13.2 Formatting of a whole table or list
------------------------------------------

If the Texinfo command is a key of the `%format_map', the associated
value is used to specify the formatting of the construct, otherwise a
function is called.  The value in `%format_map' associated with a
command is interpreted similarly with values associated with more
simpler commands:

   * If the text is a word, it is considered to be an HTML element
     name, and the whole table or list is enclosed between the element
     opening and the element closing.

   * If the text is a word followed by some text, the word and is
     interpreted as above, and the text is considered to be the
     attributes text of the element.

   * If the text is empty nothing is added to the text.

   In case the `%format_map' isn't used, a function reference called
`$table_list' should be redefined, the associated function will be
called each time a command isn't found in `%format_map'.

 -- Function Reference: $whole_table_list table_list $format_command
          $text $command $formatted_command $item_nr $enumerate_style
          $prepended_texi $prepended_formatted \@columnfractions
          \@prototype_row \@prototype_lengths $column_number
     $FORMAT_COMMAND is the Texinfo command name, $TEXT is the
     formatted items. $COMMAND is the "format command" given in argument
     to the format command, $FORMATTED_COMMAND is the same, but
     formatted.  $PREPENDED_TEXI is the remaining text on the format
     command line, $PREPENDED_FORMATTED is the same, but formatted.
     Only relevant in `@enumerate', $ITEM_NR is the item number, and
     $ENUMERATE_STYLE is the `@enumerate' style. Only relevant in
     `@multitable' \@COLUMNFRACTIONS is a reference on an array
     containing the `@columnfraction' arguments, if any,
     \@PROTOTYPE_ROW is a reference on an array containing the row
     prototypes given on the `@multitable' line, if any,
     \@PROTOTYPE_LENGTHS array contains the lengths of the row
     prototypes formatted and $COLUMN_NUMBER is the maximal number of
     columns.

   If you still want to use `%format_map' but differently from the
default, it is possible to redefine the following function reference:

 -- Function Reference: $whole_table_list format $command $format $text
     $COMMAND is the @-command, $FORMAT is the entry associated with
     $COMMAND in `%format_map'. $TEXT is the formatted items.

7.14 Definition commands formatting
===================================

The formatting of definition commands is controlled by a main hash, 3
strings and another hash, and and five functions. The mainhash
describes how the text on the definition line is interpreted, the
functions control the formatting of the definition line and the
definition function text.

7.14.1 Customizing the interpretation of a definition line
----------------------------------------------------------

The keys of the hash `%def_map' are definition command names.  There
are two types of entries:

   * If the command is a shortcut for another definition command the
     value is a text and the definition command is replaced by the text.

     For example if we have:
          $def_map{'deftruc'} = '@defvr {A truc}';

     and a line like
          @deftruc var

     the line will be transformed in
          @defvr {A truc} var

   * If the command isn't a shortcut, it is associated with an array
     reference. The first element is `f', `v' or `t' corresponding with
     the index type (`f' for function, `v' for variable, `t' for type).

     The remaining of the array describes how to interpret the text
     following the definition command on the definition command line.
     The entry item specify what corresponds with the next bracketed
     item or word. Currently the possibilities are `category', `name',
     `type', `class', `arg' and `argtype'.  `arg' means that the
     arguments are not mixed with type definitions, with `argtype'
     types are mixed with definitions. When there is no `arg' nor
     `argtype' it is the same than  `argtype' (like makeinfo).

     For example if we have
          def_map{'defvr'} = [ 'v', 'category', 'name' ];

     The first bracketed item following `@defvr' is considered to be
     the category and the next one is the name. The index associated
     with the definition line is the variables index.

   Some characters are special with regard with definition parsing, they
are delimiters, the can have a role in definition argument
determination, and also hae a special meaning in arguments parsing.
This is not very well documented in the texinfo manual, so it is
subject to change. Strings allow to determine the delimiters:

`$def_argument_separator_delimiters'
     Characters that separate arguments, currently `()[],'.

`$def_always_delimiters'
     Character that are always delimiters, if they appear in a type or a
     parameter, `()[]'.

`$def_in_type_delimiters'
     Character that are considered as delimiters only if in a type. In
     a parameter they are part of the parameter.

7.14.2 Customization of the definition formatting
-------------------------------------------------

Five functions are used when formatting a definition command:

*category name*
      -- Function Reference: $category definition_category $category
               $class $style $command
          This function precise a category name associating a class
          $CLASS (if given) with $CATEGORY. The $STYLE of the
          definition may be `f', for function, `v', for variable or `t',
          for type. The $COMMAND is the definition @-command.

      -- Function Reference: $entry definition_index_entry $name $class
               $style $command
          This function precise a name associating a class $CLASS (if
          given) with $NAME. This is used to do an index enntry
          associated with th edefinition command. The $STYLE of the
          definition may be `f', for function, `v', for variable or `t',
          for type. The $COMMAND is the definition @-command.

*formatting of the definition line*
      -- Function Reference: $line def_line $class_category_class $name
               $type $arguments $index_label \@arguments_array
               \@arguments_type_array \@unformatted_arguments_array
               $command $class_name $category $class $style
               $original_command
          This function formats the definition line. $CLASS_CATEGORY is
          the category formatted with `$definition_category', $NAME,
          $TYPE and ARGUMENTS are the element of the definition line.
          $INDEX_LABEL is the text inserted at the place where an index
          entry appears.  See Index entry place.  \@ARGUMENTS_ARRAY
          is an array holding the definition arguments, formatted.
          \@ARGUMENTS_TYPE_ARRAY holds the type of the definition
          arguments, like `name', `type' and similar arguments,
          `paramtype'.  `delimiter' and  `param'.
          \@UNFORMATTED_ARGUMENTS_ARRAY holds the arguments without
          @-command substitution. $COMMAND is the definition command,
          after substitution.  $CLASS_NAME is the class applied on
          name, formatted as specified in `definition_index_entry'.
          $CATEGORY and $CLASS are the corresponding arguments. $STYLE
          corresponds with the index style, as explained above.
          $ORIGINAL_COMMAND is the unmodified definition @-command.

*definition text*
      -- Function Reference: $definition_text def_item $text
          This function formats the definition text, $TEXT.

*the whole definition*
      -- Function Reference: $definition def $text
          This function formats the whole definition. The definition
          line and text formatted by the above functions are in $TEXT.

7.15 Customizing headings formatting
====================================

A function controls the formatting of sectioning element headings, with
the corresponding function reference:

 -- Function Reference: $heading_text heading \%element_reference
     The \%ELEMENT_REFERENCE is a reference on a hash corresponding
     with the sectioning element. The following keys are of interest:
    `text'
          The heading text

    `name'
          The heading text without section number

    `node'
          true if the sectioning element is a node without associated
          structuring command

    `level'
          The level of the element in the document tree. `0' is for
          `@top', `1' for `@chapter' and so on

    `tag_level'
          the sectioning element name, with `@raisesections' and
          `@lowersections' taken into account

    `top'
          true if it is the top element

   It is also possible to customize the heading text with section number
with the following function reference (called for headings and nodes):

 -- Function Reference: $result_texi heading_texi $heading_command
          $heading $number
     $HEADING_COMMAND is the sectioning @-command of that heading.
     $HEADING is the texinfo for that heading. $NUMBER is the heading
     number classicaly computed with dots between numbers, and letters
     for top level appendix numbering. This function should return the
     texinfo text corresponding with the numbered heading.

   The label associated with the heading that can appear before the
heading itself and even before the navigation panel is customized with
the following function reference:

 -- Function Reference: $element_label element_label $identifier
          \%element_reference $command $unformatted_line
     $IDENTIFIER is the identifier associated with the heading.
     \%ELEMENT_REFERENCE is the same as above. $COMMAND is the @-command
     appearing on the line, and $UNFORMATTED_LINE is the line,
     unformatted.

   Additionally, for `@node' and sectionning @-commands the formatting
of the label, navigation panel and heading is controlled by:

 -- Function Reference: $element_heagin_text element_heading
          \%element_reference $command $command_texi_arg $formatted_arg
          $in_preformatted $one_section $element_heading $first_in_page
          $is_top $previous_is_top $unformatted_line $element_id
          $new_element
     \%ELEMENT_REFERENCE is the same as above. $COMMAND is the heading
     @-command.  $COMMAND_TEXI_ARG is the argument of the @-command,
     unformatted. $FORMATTED_ARG is is the argument of the @-command,
     formatted. $IN_PREFORMATTED is true if in preformatted
     environment. $ONE_SECTION is true if there is only one section.
     $FIRST_IN_PAGE is true if this is the first heading  in a page.
     $IS_TOP is true if the heading is considered as a top element
     heading.  $PREVIOUS_IS_TOP is true if the previous helement was a
     top element.  $UNFORMATTED_LINE holds the whole line, unformatted.
     $ELEMENT_ID is the id of the heading. $NEW_ELEMENT is true if the
     heading is the first of an element block.

7.16 Formatting of special regions (`@verbatim', `@cartouche', `@quotation')
============================================================================

Regions corresponding with raw text, like `@verbatim', `@html' or
`@tex' are formatted according to the following function reference:

 -- Function Reference: $raw_region raw $command $text
     $COMMAND is the command name, $TEXT is the raw text.

   If LaTeX2HTML is used, `@tex' regions are handled differently,
(see Bypassing normal formatting).

   The `@cartouche' command formatting is controlled by the function
reference:

 -- Function Reference: $cartouche cartouche $text
     $TEXT is the text appearing within the cartouche.

   The formatting of `@quotation' and `@smallquotation' is controlled
by two function references.  The first one is usefull in case the
`@quotation' has an argument, as it allows to prepend a string to the
quotation text:

 -- Function Reference: $prepended_string quotation_prepend_text
          $command $text
     $COMMAND is the @-command.  $TEXT is the argument of the quotation
     with @-commands not interpreted. This function can return a string
     which will be prepended to the quotation text.

   The whole quotation is formatted by:

 -- Function Reference: $quotation quotation $command $quotation_text
          $argument_text $argument_text_texi
     $COMMAND is the @-command.  $QUOTATION_TEXT is the quotation text,
     formatted, with the text prepended by the function above.
     $ARGUMENT_TEXT is the argument of the `@quotation', formatted.
     $ARGUMENT_TEXT_TEXI is the argument of the `@quotation', simply
     formatted.

7.17 Menu formatting
====================

There are two possibilities for menu formatting:

   * format the whole menu in a preformatted environment, like in
     Complex formats;

   * format the menu in table with more specialized formatting for each
     part of the menu;

   The simple formatting in a preformatted is used if `$SIMPLE_MENU' is
true, otherwise the format with tables is used (this is the default).

   If `$USE_ACCESSKEY' is set, the `accesskey' attribute is used in
anchors. In that case the `%BUTTONS_ACCESSKEY' hash is used for the
access key.

   To understand how the formatting of menus is controlled, the
different parts of a menu are first described, then how to control the
formatting of each of these parts, for each possible formatting.

7.17.1 The structure of a menu
------------------------------

In `texi2html', a menu is considered to be composed of 2 parts, the
"menu entries" and the "menu comments". Menu entries are further
divided in an "entry link" and optionnaly an "entry description".  The
entry link consists in a node name and an optionnal menu entry name.

   A menu entry begins with `*' at the beginning of the line. It begins
with the entry link, followed by the description. The description spans
until the next menu entry, or an empty line not contained within a
command block which begun in the description. An empty line or starts a
menu comment, which spans until the next menu entry.

   Here is an illustration of these rules:

     @menu
     * entry name: node name.        description begins
        description continues
     * another menu entry::
        description begins
                         description continues

        A menu comment, after an empty line

     * node::                        description begins
     still in description.

     * last entry::         description begins @emph{text

     of the description, even if there is an empty line,
     because we are in @emph}.
     @end menu

7.17.2 The formatting of the different menu components
------------------------------------------------------

If in a preformatted context (and `$SIMPLE_MENU' isn't set), the menu
link and description are put in the same preformatted environment.
This can be avoided with `$SEPARATE_DESCRIPTION'.

   Two function references are associated with the formatting of the
different parts of a menu:

 -- Function Reference: $link menu_link $section \%state $href $node
          $name $ending $has_name $command_stack $preformatted
     $SECTION is the section name corresponding with the link, $HREF is
     the link hypertextual reference. $HREF may be absent. \%STATE
     holds informations about the current context.  $NODE is the node
     name, $NAME is the name of the node. $ENDING is the text ending
     the link entry, in general `::' followed by some spaces.
     $HAS_NAME is true if the entry has an explicit name, otherwise
     $NAME has been constructed using the formatted node name.
     $COMMAND_STACK is an array containing the commands enclosing the
     menu link. It is used in the default case to detect if the menu
     link is right in the `@menu' or not, since if it is not right
     below the menu the formatting is simpler.  $PREFORMATTED is true
     if in preformatted context.  See Three contexts.

   This command is not called if `$SIMPLE_MENU' is set.

 -- Function Reference: $description menu_description $description_text
          \%state $element_text
     $DESCRIPTION_TEXT is the text of the menu description.  The
     formatted link is also here if in preformatted context and
     `$SEPARATE_DESCRIPTION' is not set.  \%STATE should be used
     similarly than for the menu link. $ELEMENT_TEXT is the heading of
     the element associated with the node.  $COMMAND_STACK and
     $PREFORMATTED are the same than for the menu link.

   The "menu comment" part is formatted like a normal command, called
`menu_comment'. It is only used if not in preformatted environment and
if just below a `@menu' since otherwise one cannot tell if it is a menu
commment or normal text.  The default is to have it be formatted like a
Complex formats, with
     $complex_format_map->{'menu_comment'} =
     {
        'begin' => q{"<tr><th colspan=\"3\" align=\"left\" valign=\"top\">"},
        'end' => q{"</th></tr>"}, 'pre_style' => "$MENU_PRE_STYLE", 'class' => 'menu-comment',
     }

7.17.3 Simple menu formatting in a preformatted environment
-----------------------------------------------------------

If the menu is to be formatted in a single preformatted environment, an
entry for `menu' and `detailmenu' should be added to the
`$complex_format_map' hash reference (see Complex formats).  In the
default case, if the user didn't add an entry himself, a very simple
entry is used, with:

     $complex_format_map->{'menu'} = { 'begin' => q{''} , 'end' => q{''},
         'pre_style' => "$MENU_PRE_STYLE", 'class' => 'menu-preformatted' };

7.17.4 The formatting of the menu in a table
--------------------------------------------

In the default case, the name of the section corresponding with the
node is used instead of the node name. If `$NODE_NAME_IN_MENU' is true,
however, node names are used. If `$AVOID_MENU_REDUNDANCY' is true and
menu entry equal menu description the description isn't printed.  This
is the default. Likewise, if node or section name equal entry name, do
not print entry name.

   A symbol, `$MENU_SYMBOL' is put at the beginning of menu entries
when the node name is used. The default is `&bull;'.  If `$UNNUMBERED_SYMBOL_IN_MENU'
is true it is also put at the beginning of unnumbered section names.
This is not done by default.

   The menu comments are considered to be preformatted text. The style
associated with this preformatted text is determined by `$MENU_PRE_STYLE'.
Default is `font-family: serif'.  The entry similar with an entry in
`$complex_format_map' (see Complex formats) used when the menu
appears in a preformatted enviroment is in `$MENU_PRE_COMPLEX_FORMAT',
and, in the default case is:
     $MENU_PRE_COMPLEX_FORMAT = {
                   'pre_style' => $MENU_PRE_STYLE,
                   'class' => 'menu-preformatted'
        };

   The css class associated with menu comments is `menu-comments'.

   The following function reference controls the formatting of a wole
menu or a detailmenu in that case:

 -- Function Reference: $menu menu_command $command
          $menu_components_text
     $COMMAND is the menu command, currently `menu' or `detailmenu'.
     $MENU_COMPONENTS_TEXT is the formatted menu components text,
     obtained as explained above.

7.18 Indices formatting
=======================

Two different things needs to be handled for indices formatting, the
place where the index term appears, the index entry, and the index list
itself.  The indexing commands like `@cindex' determines where index
entries appear, and the index list is printed with a `@printindex'
command.

7.18.1 Formatting of index entries
----------------------------------

Index entry places in the main text may be the target for hypertext
references. Their formatting is controlled by the function associated
with the following function reference:

 -- Function Reference: $target index_entry_label $identifier
          $preformatted $entry $index_name $index_command $texi_entry
          $formatted_entry
     $IDENTIFIER should be used to create a target for links (typically
     associated with a name or id attribute in HTML).  $PREFORMATTED is
     true if the index entry appeared in preformatted text.  $ENTRY is
     the index entry with all the @-commands removed.  $INDEX_NAME is
     the index name, $COMMAND is the index command which may be a index
     command like `@cindex', but also a definition or a table.
     $TEXI_ENTRY is th eindex entry with @-commands, and
     $FORMATTED_ENTRY the entry formatted.

   Regular index entries are (like `@cindex') are formatted using the
following function reference:

 -- Function Reference: $index_entry index_entry_command $command
          $index_name $label $entry_texi $entry_formatted
     $COMMAND, $INDEX_NAME, $ENTRY_TEXI and $ENTRY_FORMATTED are the
     same as above, and $LABEL is what could be used as a label,
     formatted using the function above.

7.18.2 Customizing the formatting of index lists
------------------------------------------------

There is an elaborate default index formatting in texi2html, with index
summary by letter linking to index entries grouped by letters too, with
the possibility of index pages split accross files. This system may be
completly bypassed by redefining the function reference that is called
when `@printindex' is encountered:

 -- Function Reference: $index_text printindex $index_name
     $INDEX_NAME is the index name appearing on the `@printindex' line.
     The index formatted should be returned by this function reference.

   If the default index formatting is used, there are still
possibilities to customize part of the formatting.  The index entries
are sorted alphabetically. A whole index list is considered to be
composed of letter entries. A letter entry is composed by all the index
entries beginning with that letter. A letter may be a non alphabetical
character, but we call it letter here.

   An index summary appears at the beginning and at the end of an index
list, and should be used to jump directly to a letter entry. Indices
lists may be split across pages, thus the different letters may appear
on different files. The number of index entries appearing on each page
is determined by a variable `$SPLIT_INDEX' if set. The default is to
split indices after 100 entries.

   The formatting of all these elements is controlled by the following
function references:

_formatting of a letter in a summary_
      -- Function Reference: $letter summary_letter $letter $file
               $identifier
          This function is used to format a letter appearing in a
          summary, refering to a letter entry in the index list.
          $LETTER is the letter. $FILE is the file name where the letter
          entry appears. More precisely, it is empty when the letter
          entry is on the same page than the summary, it contains the
          file name when the index page is split accross page.
          $IDENTIFIER is an identifier for the target letter entry.

_formatting of a summary_
      -- Function Reference: $summary index_summary
               \@alphabetical_letters \@nonalphabetical_letters
          \@ALPHABETICAL_LETTERS and \@NONALPHABETICAL_LETTERS contain
          the formatted summary letters, formatted with the above
          function.

_formatting of an index entry_
      -- Function Reference: $entry index_entry $entry_href $entry_text
               $section_href $section_heading
          $ENTRY_HREF is a reference to the place where the index entry
          appeared, $ENTRY_TEXT is the corresponding text. $SECTION_HREF
          is a reference to the beginning of the sectioning element
          containing the index entry, $SECTION_HEADING is the heading
          of the element.

_formatting of letter entry_
      -- Function Reference: $letter_entry index_letter $letter
               $identifier $index_entries_text
          This function formats a letter entry, consisting in all the
          index entries beginning with this letter. $LETTER is the
          letter, $IDENTIFIER should be used to create a target for
          links (typically links from summaries), and
          $INDEX_ENTRIES_TEXT is the text of the index entries
          formatted as described above.

_formatting of whole index_
      -- Function Reference: $index print_index $index_text $index_name
          $INDEX_TEXT is the text of all the index entries grouped by
          letter appearing in that page formatted as above. It is undef
          if there are no entries or theindex name isn't known.
          INDEX_NAME is the name of the index, the argument of
          `@printindex'.

7.19 Floats and lists of floats
===============================

Floats appear in the `@float' environment, optionaly with a style and a
label, and with optionnal `@caption' and `@shortcaption'.  Their list
appear after a `@listoffloats'.

   A hash reference is associated with each float, it is available in
some formatting functions. The keys are:
`caption_texi'
`shortcaption_texi'
     A reference on an array containing the caption or shortcaption
     lines, with texi @-commands.

`style_texi'
     The style with texi @-commands.

`style_id'
     The unique identifier associated with the style.

`style'
     The style formatted.

`nr'
     The number with the same conventions than makeinfo (use the
     chapter number a dot and then the number of the float of that
     style in the chapter, or an absolute number if in unnumbered).

`chapter_nr'
     The number of the chapter containing the float.

`nr_in_chapter'
     The number of the float in the chapter.

`absolut_nr'
     The number of the float in the document.

`texi'
     The label with @-commands.

`name'
     The label formatted.

`id'
     The unique identifier associated with the label. Usefull to make
     an anchor or a reference.

`target'
     The target that can be used to refer to that float.

`element'
     A reference on a structure representing the element the float
     appear in.

7.19.1 Formatting a float
-------------------------

First there is an occasion to construct a texinfo text for the caption,
using the caption texinfo lines and the informations in the float
structure.  The returned lines will be formatted in the main program. A
function reference is used here:

 -- Function Reference: (\@caption_lines_returned,
\@shortcaption_lines_returned) caption_shortcaption \%float
          \@caption_lines \@shortcaption_lines
     \%FLOAT is the structure defined above. \@CAPTION_LINES and
     \@SHORTCAPTION_LINES are references on arrays containing the
     texinfo lines for caption and short caption.
     \@CAPTION_LINES_RETURNED and \@SHORTCAPTION_LINES_RETURNED are
     references on an array containing the texinfo lines for the
     caption and shortcaption.

   Then the float is formatted with the following function reference:

 -- Function Reference: $text float $float_text \%float $caption_text
          $shortcaption_text
     $FLOAT_TEXT is the text appearing within the `@float', formatted.
     \%FLOAT is still the structure defined above. $CAPTION_TEXT and
     $SHORTCAPTION_TEXT are the caption and short caption build with the
     above function and formatted.

   It is also possible to do something when a caption or a shortcaption
appear with t hefollowing function reference:

 -- Function Reference: $text caption_shortcaption_command $command
          $formatted_caption \@texi_lines \%float
     $COMMAND is the @-command, `caption' or `shortcaption'.
     $FORMATTED_CAPTION is the caption text, formatted, while
     \@TEXI_LINES is a reference on an array containing the caption
     lines, this time without any formatting.  \%FLOAT is still the
     structure defined above.

     In the default case this function reference returns an empty
     string.

7.19.2 Formatting lists of floats
---------------------------------

A list of floats is introduced by `@listoffloats'. The argument of
`@listoffloats' is the "style". First the style texinfo can be modified
with the following function reference:

 -- Function Reference: $style_texi_returned listoffloats_style
          $style_texi
     $STYLE_TEXI is the `@listoffloats' argument with texinfo
     @-commands kept. It is possible to make changes to the $STYLE_TEXI
     and return a modified string, still with @-commands. The modified
     string is formatted in the main program.

   After that, for each of the floats with that style, first there is a
possibility to modify the float style and the float caption before they
are formatted in the main program, with the following function
references:

 -- Function Reference: $float_style_texi_returned
listoffloats_float_style $style_texi \%float
     $STYLE_TEXI is the style, and \%FLOAT is the structure described
     above. This function reference returns a style to be formatted in
     the main program.

 -- Function Reference: $caption_texi_returned listoffloats_caption
          \%float
     \%FLOAT is the structure described above. This function reference
     returns a caption to be formatted in the main program.

   Each entry is formatted by:

 -- Function Reference: $listoffloats_entry listoffloats_entry
          $style_texi \%float $float_style $caption $href
     $STYLE_TEXI is the style with @-commands, $FLOAT_STYLE is the
     style returned by the above function and formatted. $CAPTION is the
     caption returned by the above function formatted. \%FLOAT is the
     structure corresponding with the float, and $HREF is an href
     pointing to the float location.

   Lastly, the whole `@listoffloats' is formatted by:

 -- Function Reference: $listoffloats listoffloats $style_texi $style
          \@listoffloats_entries
     $STYLE_TEXI is the style with @-commands, $STYLE is the style
     returned by the above function and formatted. The array reference
     \@LISTOFFLOATS_ENTRIES holds the entries formatted by the above
     function.

7.20 Customizing the footnotes formatting
=========================================

Each footnote is associated with a footnote entry. Several footnote
entries are grouped in a footnote section. When a footnote appears, two
things must be formatted: in the main text the place where the footnote
appear and the footnote text.

   Two functions, with corresponding function references control the
formatting of the footnotes:

 -- Function Reference: (\@lines $text_for_document) foot_line_and_ref
          $number_in_doc $number_in_page $footnote_id $place_id
          $document_file $footnote_file \@lines \%state
     $NUMBER_IN_DOC is the footnote number in the whole document,
     $NUMBER_IN_PAGE is the footnote number in the current page.
     $FOOTNOTE_ID is an identifier for the footnote in the footnote text
     which should be used to make target for references to that
     footnote, while $PLACE_ID is an identifier for the location of the
     footnote in the main document. Similarly, $DOCUMENT_FILE is the
     file name of the file containing the text where the footnote
     appears in the main document, while $FOOTNOTE_FILE is the file
     name of the file where the footnote text appears.

     \@LINES is a reference on an array containing the footnote text
     lines, allready formatted.  And \%STATE holds informations about
     the context at the footnote place in the main document. As usual
     the most usefull entry is `preformatted' which is true if the
     footnote appears in a preformatted context.

     This function returns a reference on an array, \@LINES containing
     the updated footnote text for the footnote entry, and
     $TEXT_FOR_DOCUMENT, the text appearing at the footnote place in
     the main document, linking to the footnote entry.

   The following function is only used when footnotes are at the bottom
of a page and the document is split.  For customization of the
footnotes page in case they are on a separated page or section, see
Special pages layout. For the determination of the footnote
locations, see Page layout options.

 -- Function Reference: foot_section \@footnotes_lines
     This function formats a group of footnotes. \@FOOTNOTES_LINES is a
     reference on an array holding the lines of all the footnote entries
     formatted as explained above. This function modifies the reference.

7.21 Customizing format opening
===============================

The following function reference is called when a format is opened.  A
format is any @-command that ends with a `@end' except @-commands that
only select if the input is processed (like `@ignore' or `@ifhtml') or
raw @-commands (like `@verbatim' and `@html').

 -- Function Reference: $line begin_format_texi $command $line \%state
     The $COMMAND is the format command, the $LINE is the line
     following the @-command, \%STATE is a reference on a hash
     containing many formatting information. It can modify the line and
     return something else.

     In the default case, it is used to keep track of the multitable
     nesting.  As a consequence, it is linked with the multitable
     formating.  See Multitable formatting.

7.22 Bypassing normal formatting
================================

It is possible to bypass completely the normal formatting of @-commands
with braces and raw regions (`@html', `@tex', `@xml'... regions).  In
that case the @-commands and the text within are passed to a user
defined function early, in a pass when no expansion of output takes
place, called the collecting pass. Another user defined function is
called during the output expansion phase.

   Moreover, arbitrary user defined functions may be called between the
different texinfo parsing and outputting passes. This could be used, for
example to initialize some things before collecting the @-commands and
their text, expanding them between the collecting and expansion phase
and doing some cleaning after the expansion pass. These possibilities
are used for the interface to LaTeX2HTML (see Expanding TeX regions),
and the examples are taken from that use.

   The @-commands that are keys of the `%command_handler' hash are
collected in the collecting pass and expanded in the expansion pass
using user defined functions. The associated value is a reference on a
hash used to specify the user defined function references.  The key of
the hash reference are `'init'' for the function reference called
during the collecting pass, and `'expand'' during the expansion pass.
Here is an example for an @-command with braces:

     $command_handler{'math'} =
          { 'init' => \&Texi2HTML::LaTeX2HTML::to_latex,
            'expand' => \&Texi2HTML::LaTeX2HTML::do_tex
          };

   And an example for a raw region @-command:

     $command_handler{'tex'} =
          { 'init' => \&Texi2HTML::LaTeX2HTML::to_latex,
            'expand' => \&Texi2HTML::LaTeX2HTML::do_tex
          };

   The function references are called like:

 -- Function Reference: $status $command_handler{'$command'}->{'init'}
          $command $text $count
     $COMMAND is the @-command name, $TEXT is the text appearing within
     the @-command. $COUNT is a counter counting how many times this
     @-command appeared. $STATUS is a boolean which should be true if
     the collecting was succesfull. If false the @-command and the text
     is discarded.

 -- Function Reference: $result
          $command_handler{'$command'}->{'expand'} $command $count
          $state $text
     $COMMAND is the @-command name, $COUNT is a counter counting how
     many times this @-command appeared. $STATE is a reference on a
     hash containing many informations about the context. $TEXT should
     be empty. $RESULT is the expanded resulting text.

   There are three places for user defined functions, associated with
arrays:
`@command_handler_init'
     The function references in that array are called before the
     collecting pass.  At that time the information available is
     essentially the file names.

`@command_handler_process'
     The function references in that array are called between the
     collecting pass and the expansion pass. At that time all the
     special @-commands have been collected as explained above but no
     output has been produced.

`@command_handler_finish'
     he function references in that array are called after the end of
     the output generation.

   Here is an example of these arrays use:

     push @command_handler_init, \&Texi2HTML::LaTeX2HTML::init;
     push @command_handler_process, \&Texi2HTML::LaTeX2HTML::latex2html;
     push @command_handler_finish, \&Texi2HTML::LaTeX2HTML::finish;

7.23 Handling special regions
=============================

Special regions `@titlepage', `@documentdescription' and  `@copying'
are removed from the document before the last pass in the default case.
They can be kept if the value associated with the @-command in the `%region_formats_kept'
hash is true.

   The `@insertcopying' @-command is formatted by

 -- Function Reference: $insertcopying insertcopying $text $comment
          $simple_text
     $TEXT is the text appearing in `@copying', formatted.  $COMMENT is
     the text with texi removed, should be very simple text.
     $SIMPLE_TEXT is the text formatted in string context.

   The title page handling is described in Title page.

7.24 Customizing other commands, and unknown commands
=====================================================

Many commands without braces are available in texinfo, sometimes with a
specific syntax. For example we have `@sp', `@noindent',
`@documentlanguage', `@oddheading', `@headings', `@shortcontents',
`@shorttitlepage' or `@comment'.  `texi2html' interprets some of these
commands and some functions or variables are used for their formatting
or to access their information.  In the default case, however, most of
these constructs are ignored.

   It is possible to change how the things following these commands on
the line are handled, what is considered to be an arg for those
commands and it is also possible to keep them instead of discarding
them such that it is possible to handle them specially, with the same
function than the one used for unknown commands.

   Those special commands without braces are the key of a hash: `%misc_command'.
The associated value is a reference on a hash enabling to set the
properties of these commands. The keys of this hash reference is the
name of a property, the value is the value of the property. For example
here we have `line' for the `arg' property for the `command' @-command.

     $misc_command{'command'} = {'arg' => 'line', 'skip' => 'space'};

   The properties and possible values are:

`skip'
     This property enables to set what is skipped after the command
     arguments.  Here are the possible values:
    `line'
          The remaining of the line is skipped.

    `space'
          Spaces are skipped but not newline.

    `whitespace'
          Spaces are skipped

    `linewhitespace'
          Spaces are skipped if there are only spaces remaining on the
          line.

    `linespace'
          Spaces are skipped, but not newline if there are only spaces
          remaining on the line

`arg'
     If the associated value is `line' the line is considered to be the
     argument. If it is a number it is the number of args (separated by
     spaces).

`keep'
     If true the args and the macro are kept, otherwise they are
     discarded.  The defaut is to have `keep' undef for all the
     commands.  If `keep' is true for `@verbatiminclude' the default
     action for this macro isn't done.

   Commands which don't appear in the hashes `%simple_map', `%simple_map_pre', `%simple_map_texi'
and `%misc_command', or that appear in `%misc_command' but with `keep'
true are processed by the following function reference:

 -- Function Reference: ($result_line, $result, $result_text, $message)
unknown $command $line $pass
     $COMMAND is the @-command, $LINE is the line following the
     $COMMAND. $PASS is the pass of texi2html (see Three passes).
     $RESULT is a boolean. If it is true then the other return values
     are taken into account otherwise the default actions are used. In
     case $RESULT is true, $RESULT_LINE is the new line to be processed
     further, $RESULT_TEXT is the resulting formatted text and
     $MESSAGE, if defined is a message outputted to the output with
     line number added by `texi2html'.

   Commands with braces not specified above nor in `%style_map', `%style_map_pre'
and `%style_map_texi' are processed by the following function reference

 -- Function Reference: ($result, $result_text, $message) unknown_style
          $command $text
     $COMMAND is the @-command, $TEXT is the text appearing within the
     braces (allready formatted). $RESULT is a boolean. If it is true
     then the other return values are taken into account otherwise the
     default actions are used. In case $RESULT is true, $RESULT_TEXT is
     the resulting formatted text and $MESSAGE, if defined is a message
     outputted to the output with line number added by `texi2html'.

Appendix A Internationalization
*******************************

The strings written in the document are selected based on the document
language. This can be used to customize the strings, as described in
Strings. This also enables translation of the strings.

A.1 Translating strings
=======================

A.1.1 Contributing to existing translations
-------------------------------------------

If the language is allready supported, then there will be a file in the
`i18n' directory with name the two-letter ISO-639 language code. In
that case you can enhance the translations by editing this file. There
is a `$LANGUAGES->{'LANGUAGE'}' hash in that file. The keys are the
english strings, in `''', the values (in `''' after `=>') are the
translations.  When a string contains a `%' followed by `{' NAME `}' it
means that the string will be expanded by `texi2html'. For an example,
see Strings.

   After that you should run the command `./manage_i18n.pl merge' in
the top directory, it should merge your file with the existing files in
`translations.pl', which is incorporated to the `texi2html' script by
`make'.

A.1.2 Contributing translations to another language
---------------------------------------------------

If the language isn't currently supported, copy the `en' file in `i18n'
to a file with name the two-letter ISO-639 language code of your
language  and then add your translations to the strings. You could also
add your two-letter language code in the `manage_i18n.pl' file in the
`@known_languages' array.

   After that you should run the command `./manage_i18n.pl update LANG'
and `./manage_i18n.pl merge' in the top directory.

   Obsoleted strings are not removed from the files, they are still
present in the `$T2H_OBSOLETE_STRINGS->{'LANGUAGE'}' hash in case the
string is reused later.

   If you made change to strings specified in installed files (see
Installation) you will have to reinstall them otherwise the
installated files will take precedence (see Using init files).

A.2 Adding new strings written to document
==========================================

If you need to write strings, for example the new string A STRING to
the resulting document, call `&$I('a string')'. Use simple quotes.  If
you want to substitute a value in the string put `%{STRING_VALUE}', in
the string, and give a second argument to `&$I', a hash reference with
key STRING_VALUE and value the what you want to substitute.  Here is an
example:

     return &$I('%{name} of %{class}',
            { 'name' => $name, 'class' => $class });

   In that case `%{name}' is substituted by `$name' in the translated
string.

   After that you should run the command `./manage_i18n.pl' in the top
directory, to add your new strings to the template file, that is the
file for english and to all the files in the `i18n' directory. This is
achieved with

     ./manage_i18n.pl template
     ./manage_i18n.pl update

   These two commands won't work if you don't have the `Data::Dumper'
module installed.  And to merge the new translation files in
`translations.pl', do

     ./manage_i18n.pl merge

   All these steps may be performed by `make', once the language file
is added to `Makefile.am' in the `i18n_files' variable.

2 Incompatibilities with previous versions
******************************************

`texi2html' has accumulated a lot of incompatibilities with previous
versions. They are documented in the `NEWS' file, we discuss them here
nevertheless. Most of the incompatibilities were introduced in version
1.68. API changed also a lot between 1.78 and 1.80.

   * API changes between 1.78 and 1.80:
        * what was done in the beginning of the $print_section function
          reference is now done in $print_element_header.

        * there is a new argument for $normal_text.

        * there is a new argument for $menu_link and $simple_menu_link,
          and the name argument is always set, even if there is no
          explicit name. The new argument is true if there really was
          an explicit name.

        * $internal_ref and $external_ref don't change inforef to xref
          anymore.

        * in $table_item the text is not formatted with the format
          command,   the text_formatted argument is.

        * definition index entries are now formatted with
          $definition_index_entry,   not with $definition_category
          anymore.

        * $printindex is called if an index appears, even if the index
          is not defined or there are no index entries.

        * new argument (@-command name) for $quotation and
          $quotation_prepend_text.

        * change in the heading API. THIS_HEADER is not used anymore.
          New function reference, element_heading  to format a node or
          a section   heading, including navigation and label.
          Accordingly, print_Top and   one_section don't print the
          element header anymore. Also it is   reported if the element
          is a new element, is the main element and   more arguments,
          and top element heading is always done in heading.

        * print_element_header and print_navigation now return their
          result.

        * the `copying' key of %Texi2HTML::THISDOC is now called
          `copying_comment'.

        * TOC_LIST_ATTRIBUTE is now called NO_BULLET_LIST_ATTRIBUTE.

        * TOC_LIST_STYLE is now called NO_BULLET_LIST_STYLE.

        * the $unknown function reference has a new argument, the pass
          number.

        * `--sec-nav' is replaced by `--headers'.

        * `--Verbose' is replaced by `--verbose'.

        * `--lang' is replaced by `--document-language'.

        * `--separated-footnotes' is replaced by `--footnote-style'.

        * `--lang' is replaced by `--document-language'.

        * `&$menu_comment' is removed, `menu_comment' is now handled
          like an @-command.

        * `@detailmenu' is now formatted more like `@menu', and the
          `&$menu' function reference is replaced by `&$menu_command'.
          `&$menu' is kept for backward compatibility. If `&$menu' is
          defined, `@detailmenu' is ignored.

        * the API for the formatting of menus completly changed.
          $simple_menu_link   is removed, everything should be done in
          $menu_link.

        * image API changed, and is unstable, so not documented.

        * image file paths are not completed anymore in the default
          case.    The previous   behaviour can be restored with
          `$COMPLETE_IMAGE_PATHS' set to true.

        * in %misc_command `texi' is not used anymore. The value and
          macros are expanded as they should be unconditionnally.

        * there is a new 'style' key in $complex_format_map, to be able
          to   differentiate complex formats inheriting fonts and
          code_style (like   @format, @display).

        * $EXTENSION should be undef if one doesn't want an extension
          to be added.

        * THISDOC{'title'} and similar are now for @title since only
          one @title   should appear in the document. @settitle is
          tried first to set fulltitle.

        * Configuration variables are modified anymore, instead the
          variable   value is put in $Texi2HTML::THISDOC{'VAR'}. This
          is the case for   DO_CONTENTS, DO_SCONTENTS, CSS_LINES,
          BODYTEXT, DOCUMENT_DESCRIPTION,   DOCUMENT_ENCODING,
          IN_ENCODING, ENCODING_NAME, OUT_ENCODING.

          For example, if $CSS_LINES is defined, the value is put in
          $Texi2HTML::THISDOC{'CSS_LINES'} which is used for
          formatting, and if   $CSS_LINES is not defined,
          $Texi2HTML::THISDOC{'CSS_LINES'} is   autodetected.

        * When there is no section and $USE_NODES is not set don't
          split by node.  This behaviour and the previous aren't
          documented, so it could change in the future.

   * API changes between 1.76 and 1.78:
        * paragraph has new arguments with indentation information,
          added as the third argument, and other context information.
          The formatting linked with commands opened before the
          paragraph and closed after the paragraph are done in the
          formatting function. Similar things are done for preformatted.

        * normal_text changed completely. There are much more arguments
          to give informations about the context, and normal_text now
          does more text manipulation.

        * New arguments for image the alt text, the height and width,
          the path to working dir and the path to image file relative
          to working dir. More image formatting is done in the
          formatting function.

        * New argument for empty_line.

        * End of line removal is done in formatting function of
          definition line formatting.

        * node_file_name now should only returns the node file, since
          the redirection file isn't used anymore. element_file_name
          only is used for file names, whatever NODES_FILES is.

   * changes between 1.66 and 1.68:
        * When the manual is split the default is to put resulting
          files in a directory with name the manual file basename
          (previously they were left in  the current directory). To
          avoid that, call texi2html with `-output .'. This has been
          changed to be compatible with `makeinfo' and also because it
          fits better with the cross manuals reference scheme.

        * The option `--output' signification changed. It now has the
          same meaning than for `makeinfo'. It seems that in 1.66 it
          was the same than `-out-file'.  `--output' new meaning allows
          to replace `-out-file' and `-subdir' with a unique option.

          More precisely `-out-file' forces the output to be unsplit
          while `--output' behaves differently when split (it specifies
          the directory where the manual files should be outputted) and
          unsplit (it specifies the output file). `-subdir' is retained
          for backward compatibility.

          If you want a backward compatibility you can use `-subdir'
          for the output directory if the document is split, and
          `-out-file' if the document isn't split. This hasn't been
          tested extensively though.

        * Many options has been obsoleted but they are retained for
          backward compatibility.

        * The init files are searched in new directories, however they
          are still searched for in the old directories for backward
          compatibility.

        * the option `--glossary' doesn't do anything. Likely nothing
          specific is done regarding bibliographies. This has been
          decided because this added some semantics to the texinfo
          formatting language that weren't part of texinfo.

          It should be possible to do something similar with macros.
          See for example `glossary.texi' for glossary and
          `my-bib-macros.texi' for bibliography in the directory
          `examples'. In the web2c package there is an example of use
          of BibTeX, see
          `http://tug.org/texlive/devsrc/Build/source/TeX/texk/web2c/doc/'
          (the examples for bibliography are taken from the texinfo
          home page `http://www.gnu.org/software/texinfo/texinfo.html').

        * don't use `T2H_CENTER_IMAGE'. `@center' should be used
          insead, it will give the right output for all the formats.

        * If a directory creation fails the program aborts. This is
          much safer.

        * The interface for internationalisation changed, although the
          previous wasn't documented a lot.

        * the API described in this manual changed a lot. A important
          change was to use the `Texi2HTML::Config' names space instead
          of variables prefixed with `T2H_' or  `t2h_'. To cope with
          the change the prefix should be removed from variables in
          init files.  Some variables are now in `%Texi2HTML::THISDOC'.

        * `@ifinfo' regions are not expanded by default. This may lead
          to warnings or errors especially if the Top node is enclosed
          in `@ifinfo', as some node won't appear in menus. The quick
          fix is to call `texi2html' with the option `--ifinfo' and the
          right way should be to make more use of `@ifnottex'.

        * The code appearing before the first node is now outputted, it
          was ignored before. `--ignore-preamble-text' revert to the
          previous behaviour. Enclosing in `@ifnothtml' would be much
          cleaner.

3 How little texi2html texinfo differs from GNU texinfo
*******************************************************

For features documented in the texinfo manual, the texinfo
interpretation by `texi2html' shouldn't differ from the interpretation
of `makeinfo' or `texi2dvi'. However for constructs with unspecified
behaviour `texi2html' often doesn't lead to the same result than
`makeinfo' or `texi2dvi'. `makeinfo' and `texi2dvi' are also
inconsistent in most of these cases (or broken). You are urged not to
use these features unless absolutely necessary.  This information is
only here to help understand why `texi2html' differ from other texinfo
interpreters, it may be inacurate and the `texi2html' behaviour may
change in the future and was different in the past.

@-commands with text on the line
     In the texinfo manual it is specified that block @-commands should
     appear on a line without text and the closing `@end' should also
     be on a line by himself. With `texi2html' it is possible to add
     text before and after the command, so the following is right:

          something @example the example @end example after the example

     `makeinfo' and `texi2dvi' may also accept text before the command
     and text after the `@end' command, sometimes ignoring it after the
     `@end'.

     This is a feature you should especially not rely on.

special @-commands handling
     The special @-commands are commands like `@pagesizes', `@sp',
     `@evenheading', `@raisesections', `@defindex' and a lot more. In
     many cases `makeinfo' and `texi2dvi' don't parse those commands
     the same way too. `texi2html' may also show some differences in
     parsing of the arguments of these commands, in case there are
     wrong arguments, and also ignore differently things following
     those commands. How user defined macros, set and values are
     expanded in those commands may also be different.  Part of the
     specification of how these commands are handled is configureable
     (see Other and unknown commands), but not what happens during
     the beginning of the parsing for some of those commands.

features different between `makeinfo' and `texi2dvi'
     When `makeinfo' or `texi2dvi' use a feature which is reserved for
     one or the other translator, `texi2html' uses that feature. So for
     example `@definfoenclose' which is ignored by `texi2dvi' is taken
     into account and `@kbdinputstyle' which is ignored by `makeinfo'
     is taken into account.

user defined macros and values
     In this area `makeinfo' and `texi2dvi' also differ a lot.  The
     reference implementation is the `makeinfo' implementation as
     `texi2dvi' is easily broken when macros are not used simply.

        * `@rmacro' and `@macro' behave exactly the same. In fact this
          goes against a documented behaviour, however if a user don't
          want a recursive macro he can simply avoid reusing the macro
          in the definition. If somebody report that the feature is
          usefull we could try to implement it.

        * It is possible to escape the end of a macro definition with
               \@end macro
          with the `\' being removed after the first expansion.
          Otherwise it is not possible to produce a `\@end macro' in a
          macro.

        * `@unmacro' is interpreted during the macro argument expansion.
          Don't know what `makeinfo' exactly do.

        * Some `@value' may be expanded later than the others, those
          that are in special commands, like `@node'.

`@,' in `@node'
     Like `texi2dvi' but unlike `makeinfo' `@,' don't break `@node'
     arguments like a regular `,'.

Things before first node or preamble
     Things before the first node or before the preamble may not be
     exactly interpreted or discarded as `makeinfo' or `texi2dvi' do.

encodings
     `texi2html' knows more encodings, in fact all encodings `perl'
     knows about.

commands in `@ifset' and `@ifclear'
     `texi2html' doesn't need a proper nesting of internal `@ifset' or
     `@ifclear' if they are in ignored or raw regions (like `@html' or
     `@verbatim'). For example the following is accepted by `texi2html'
     and not by `makeinfo':

          @ifset notset
          @ignore
          @ifset
          @end ignore
          @end ifset

     In `@ifset' and `@ifclear' texi2html also accepts a lot more of
     invalid constructs. For example the following is accepted by
     `texi2html' but not by `makeinfo':

          @set flag
          @ifset flag
          @itemize
          @item my item
          @end ifset
          text
          @ifset flag
          @end itemize
          @end ifset